(*^

::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "X Window System Mathematica Notebook Front End Version 2.2";

	X11StandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, fontName, "times";
	fontset = subtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, fontName, "times";
	fontset = subsubtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, fontName, "times";
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, fontName, "times";
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, fontName, "times";
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, fontName, "times";
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, fontName, "times";
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold,  10, fontName, "courier";
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  10, fontName, "courier";
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  10, fontName, "courier";
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  10, fontName, "courier";
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  10, fontName, "courier";
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, fontName, "courier";
	fontset = name, inactive, noPageBreakInGroup, nohscroll, preserveAspect, M7, italic, B65535,  10, fontName, "times";
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  12, fontName, "times";
	fontset = leftheader,  12, fontName, "times";
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, italic,  12, fontName, "times";
	fontset = leftfooter,  12, fontName, "times";
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "courier";
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
GRTensorM
:[font = subtitle; inactive; preserveAspect]
Defining New Objects
:[font = section; inactive; preserveAspect; startGroup]
Load Up
:[font = text; inactive; preserveAspect]
Here we load the package and the Schwarzschild spacetime so we can demonstrate GRTensorM's ability to define new objects.
:[font = input; preserveAspect; startGroup]
<<grii/grt.m
:[font = print; inactive; preserveAspect; endGroup]
 GRTensorM Version 1.0
 June 4, 1996

 Copyright 1996 by P. Musgrave, D. Pollney and K. Lake
 Use qload[] or grload[] to load a metric.
 ?grtensor for help.

 Metric directory = "/homes/gert/grtensor/mma/metrics/"
:[font = input; preserveAspect; startGroup]
qload[schw]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
Default metric = schw
For the schw metric.
 
Coordinates
  1        2         3         4
 x  = r,  x  = th,  x  = ph,  x  = t
For the schw metric.
 
Line element

           2
   2     dr        2       2 m       2  2      2  2        2
ds   = ------- + dt  (-1 + ---) + dth  r  + dph  r  Sin[th]
           2 m              r
       1 - ---
            r
:[font = section; inactive; preserveAspect; startGroup]
grdefine
;[s]
1:0,0;8,-1;
1:1,0,0 ,Courier,1,18,0,0,0;
:[font = text; inactive; preserveAspect]
You are not limited to the particular set of objects which are provided with GRTensorM. The command grdefine allows you to specify the definition of a new object. This new object can then be calculated, manipulated and displayed using GRTensor commands.

A grdefine call is of the form:

grdefine[ newObject, symmetry, definition (optional) ]

The first two arguments to grdefine are the name of the new object (as a string, see below), and the name of an existing object which has the same symmetry as the new object (or {} if the new object has no symmetries). If you wish to enter the component values explicitly, then this is all the information you need. More generally you will want to provide a tensor equation to define the new object, and this is the third (optional) argument.
;[s]
9:0,0;100,1;108,2;288,3;342,4;371,5;379,6;522,7;524,8;786,-1;
9:1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;
:[font = subsection; inactive; preserveAspect; startGroup]
Describing Tensor Expressions
:[font = text; inactive; preserveAspect]
Both the newObject and definition arguments to grdefine are strings containing tensor expressions. These strings must indicate the names, indices and index positions of a mathematical expression. GRTensorM adopts a simple set of conventions to allow this:

- indices are contained in {}'s
- indices are covariant by default
- indices preceeded by ^ are contravariant
- indices enclosed in ()'s are basis indices
- all indices after a semi-colon are covariant derivative indices
- all indices after a comma are partial derivative indices
- indices in all capitals are spinor indices (future expandability - not supported at present)
- repeated indices (one up and one down) are to be summed over
- explicit indices (i.e. coordinate names) are prefixed by $

So for example a definition of the Einstein tensor (in which we use the name G2 to avoid confusion with the existing definition) would be:
;[s]
9:0,0;9,1;18,2;23,3;33,4;47,5;55,6;834,7;836,8;895,-1;
9:1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;
:[font = input; preserveAspect; startGroup]
grdefine[ "G2{a b}", g[dn,dn], "R{a b} - 1/2 R{^c c} g{a b}"]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for G2[dn, dn]
:[font = input; preserveAspect; startGroup]
grcalc[G2[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
Created a definition for R[up, dn]
For the schw metric.
Calculated g[up, up]( 0.366667 sec.)
Calculated g[dn, dn, pdn]( 0.283333 sec.)
Calculated Chr[dn, dn, dn]( 0.35 sec.)
Calculated Chr[dn, dn, up]( 0.55 sec.)
Calculated R[dn, dn]( 0.516667 sec.)
Calculated R[up, dn]( 0.216667 sec.)
Calculated G2[dn, dn]( 0.216667 sec.)
CPU Time = 3.11667 sec.
:[font = input; preserveAspect; startGroup]
grmap[Together[#,Trig->True]&,G2[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the schw metric.
Applying Together[#1, Trig -> True] &  to G2[dn, dn]
CPU Time = 0.466667 sec.
:[font = input; preserveAspect; startGroup]
grdisplay[G2[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the schw metric.
 
G2[dn, dn]
G2[dn, dn] = All components are zero
:[font = text; inactive; preserveAspect; endGroup]
As expected  G2 vanishes for Schwarzschild. Now let's consider something a bit more interesting.
:[font = subsection; inactive; preserveAspect; startGroup]
The Bel-Robinson Tensor
:[font = text; inactive; preserveAspect]
Here we use grdefine to create a definition of the Bel-Robinson tensor and check that the resulting object is trace free and has zero divergence in vacuum.

First let us define the Bel-Robinson tensor (see Wald, p90). B-R is totally symmetric and the closest we can come to this symmetry is by using the symmetry of g[dn,dn,pdn,pdn].
;[s]
2:0,0;316,1;333,-1;
2:1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;
:[font = input; preserveAspect; startGroup]
grdefine["T{c d e f}", g[dn,dn,pdn,pdn], 
 "Weyl{a c d b} Weyl{^a e f ^b} + Weylstar{a c d b} Weylstar{^a e f ^b}"]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for T[dn, dn, dn, dn]
:[font = text; inactive; preserveAspect]
Before calculating B-R we define the trace, trT[dn,dn] and the divergence divT[dn,dn,dn]
;[s]
4:0,0;44,1;54,2;74,3;88,-1;
4:1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;
:[font = input; preserveAspect; startGroup]
grdefine["trT{a b}", g[dn,dn], "T{^c c a b}"]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for trT[dn, dn]
:[font = input; preserveAspect; startGroup]
grdefine["divT{a b c}", g[dn,dn, pdn], "T{^d a b c ; d}"]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for divT[dn, dn, dn]
:[font = text; inactive; preserveAspect]
Check the trace and divergence. To speed the calculation we first calculate and simplify the
Weyl and dual Weyl tensors used in the above definitions. The $ symbol in the grmap[] command below is used like Mathematica's % recall facility. It indicates the previous list of
objects is to be used again.
:[font = input; preserveAspect; startGroup]
grcalc[{Weyl[dn,dn,dn,dn],Weyl[up,dn,dn,dn]}]
:[font = print; inactive; preserveAspect; endGroup]
Created a definition for Weyl[up, dn, dn, dn]
For the schw metric.
Calculated R[dn, dn, dn, dn]( 1.68333 sec.)
Calculated Ricciscalar( 0.05 sec.)
Calculated Weyl[dn, dn, dn, dn]( 1.05 sec.)
Calculated Weyl[up, dn, dn, dn]( 3.08333 sec.)
CPU Time = 6.53333 sec.
:[font = input; preserveAspect; startGroup]
grmap[ Factor[#,Trig->True]&, $]
:[font = print; inactive; preserveAspect; endGroup]
For the schw metric.
Applying Factor[#1, Trig -> True] &  to 
 
  Weyl[dn, dn, dn, dn]
Applying Factor[#1, Trig -> True] &  to 
 
  Weyl[up, dn, dn, dn]
CPU Time = 3.88333 sec.
:[font = input; preserveAspect; startGroup]
grcalc[{Weylstar[dn,dn,dn,dn],Weylstar[up,dn,dn,up]}]
:[font = message; inactive; preserveAspect]
grii::autoload: 
   Loading objects from grii`objects`cmscalar`CM`
:[font = print; inactive; preserveAspect; endGroup]
Created a definition for Weylstar[up, dn, dn, up]
For the schw metric.
Calculated detg( 0.0833333 sec.)
Calculated LevC[dn, dn, dn, dn]( 1.18333 sec.)
Calculated Weyl[dn, dn, up, up]( 1.81667 sec.)
Calculated Weylstar[dn, dn, dn, dn]( 1. sec.)
Calculated Weylstar[up, dn, dn, up]( 9.73333 sec.)
CPU Time = 19.5167 sec.
:[font = input; preserveAspect; startGroup]
grmap[ Factor[#,Trig->True]&, $]
:[font = print; inactive; preserveAspect; endGroup]
For the schw metric.
Applying Factor[#1, Trig -> True] &  to 
 
  Weylstar[dn, dn, dn, dn]
Applying Factor[#1, Trig -> True] &  to 
 
  Weylstar[up, dn, dn, up]
CPU Time = 6.88333 sec.
:[font = input; preserveAspect; startGroup]
grcalc[{trT[dn,dn], divT[dn,dn,dn]}]
:[font = print; inactive; preserveAspect; endGroup]
Created a definition for T[up, dn, dn, dn]
Created a definition for Weyl[up, dn, dn, up]
For the schw metric.
Calculated Weyl[up, dn, dn, up]( 9.55 sec.)
Calculated T[dn, dn, dn, dn]( 4.75 sec.)
Calculated T[up, dn, dn, dn]( 3.78333 sec.)
Calculated trT[dn, dn]( 0.133333 sec.)
Calculated T[up, dn, dn, dn, cdn]( 24.0167 sec.)
Calculated divT[dn, dn, dn]( 0.45 sec.)
CPU Time = 43.8667 sec.
:[font = text; inactive; preserveAspect]
Simplify the results before displaying them. 
:[font = input; preserveAspect]
grmap[Together[#,Trig->True]&, $, Verbose->False]
:[font = input; preserveAspect; startGroup]
grdisplay[$]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
For the schw metric.
 
trT[dn, dn]
trT[dn, dn] = All components are zero
 
divT[dn, dn, dn]
divT[dn, dn, dn] = All components are zero
:[font = subsection; inactive; preserveAspect; startGroup]
Explicit Object Definition
:[font = text; inactive; preserveAspect]
grdefine allows users to enter components of an object explicitly if they wish. For example we may wish to define a vector and specify the components explicitly. In this case we use grdefine with two parameters and calculate the object. During calculation we will be prompted for the components. 
;[s]
2:0,0;8,1;296,-1;
2:1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;
:[font = input; preserveAspect; startGroup]
grdefine["v{^a}", {}]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for v[up]
:[font = text; inactive; preserveAspect]
Calculation of v[up] will result in a series of prompts for the individual components.
:[font = input; preserveAspect; startGroup]
grcalc[v[up]]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
For the schw metric.
Calculated v[up]( 0.1 sec.)
CPU Time = 0.2 sec.
:[font = subsection; inactive; preserveAspect; startGroup]
The Kronecker delta
:[font = text; inactive; preserveAspect]
Kronecker delta symbols often appear in the definitions of  new objects. The object kdelta is provided in GRTensorII. As a simple example we define
;[s]
3:0,0;84,1;90,2;147,-1;
3:1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;
:[font = input; preserveAspect; startGroup]
grdefine["diag{^a b}", {}, "kdelta{^a b}"]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for diag[up, dn]
:[font = input; preserveAspect; startGroup]
grcalc[diag[up,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the schw metric.
Calculated diag[up, dn]( 0.116667 sec.)
CPU Time = 0.216667 sec.
:[font = text; inactive; preserveAspect]
and the result is as expected.
:[font = input; preserveAspect; startGroup]
grdisplay[$]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
For the schw metric.
 
diag[up, dn]

     r
diag     = 1
       r

     th
diag       = 1
        th

     ph
diag       = 1
        ph

     t
diag     = 1
       t
:[font = subsection; inactive; preserveAspect; startGroup]
Explicit Indices
:[font = text; inactive; preserveAspect]
Often the delta function is used to single out a particular coordinate, and one of its arguments is an explicit coordinate name and not a dummy or listing index. Explcit indices in GRTensorII are prefixed by $. When the object is calculated GRTensorII ensures the spacetime has the named coordinate.

For example, define a vector with 1 in the "t" component as follows:
:[font = input; preserveAspect; startGroup]
grdefine["tl{^a}", {}, "kdelta{^a $t}"]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for tl[up]
:[font = input; preserveAspect; startGroup]
grcalc[tl[up]]
:[font = print; inactive; preserveAspect; endGroup]
For the schw metric.
Calculated tl[up]( 0.05 sec.)
CPU Time = 0.166667 sec.
:[font = input; preserveAspect; startGroup]
grdisplay[tl[up]]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
For the schw metric.
 
tl[up]

   t
tl   = 1
:[font = subsection; inactive; preserveAspect; startGroup]
(Anti)Symmetrization
:[font = text; inactive; preserveAspect]
Symmetrization and anti-symmetrization is permitted within definitions. They are denoted by () and [] respectivly. The brackets denoting (anti)symmetrization must be inside the {} used to denote indices - but the open and close (anti)symmetrization brackets need not be in the same pair of {}'s. Indices between the () or []'s which are not be (anti)symmetrized can be protected by Bach bars `|` .

Consider the symmetrization of the covariant derivative of the previously defined timelike vector field tl[up] (i.e. the left hand side of Killing's equation).
;[s]
3:0,0;503,1;509,2;558,-1;
3:1,0,0 ,times,0,12,0,0,0;1,0,0 ,Courier,0,12,0,0,0;1,0,0 ,times,0,12,0,0,0;
:[font = input; preserveAspect; startGroup]
grdefine[ "Killing{a b}", g[dn,dn], "tl{ ( a ; b ) }"]
:[font = message; inactive; preserveAspect; endGroup]
grii::create: Created a definition for Killing[dn, dn]
:[font = input; preserveAspect; startGroup]
grcalc[Killing[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
Created a definition for tl[dn]
For the schw metric.
Calculated tl[dn]( 0.05 sec.)
Calculated tl[dn, cdn]( 0.166667 sec.)
Calculated Killing[dn, dn]( 0.0833333 sec.)
CPU Time = 0.966667 sec.
:[font = text; inactive; preserveAspect]
Examine both the derivative of the timelike vector, and the symmetrized derivative.
:[font = input; preserveAspect; startGroup]
grdisplay[{tl[dn,cdn],Killing[dn,dn]}]
:[font = print; inactive; preserveAspect; endGroup; endGroup; endGroup; endGroup]
For the schw metric.
 
tl[dn, cdn]

          m
tl      = --
   r ;t    2
          r

            m
tl      = -(--)
   t ;r      2
            r
 
Killing[dn, dn]
Killing[dn, dn] = All components are zero
^*)