(*^

::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "X Window System Mathematica Notebook Front End Version 2.2";

	X11StandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, fontName, "times";
	fontset = subtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e6,  18, fontName, "times";
	fontset = subsubtitle, inactive, noPageBreakBelow, noPageBreakInGroup, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, fontName, "times";
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, fontName, "times";
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, fontName, "times";
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, fontName, "times";
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, fontName, "times";
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold,  10, fontName, "courier";
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  10, fontName, "courier";
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  10, fontName, "courier";
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  10, fontName, "courier";
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23,  10, fontName, "courier";
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, fontName, "courier";
	fontset = name, inactive, noPageBreakInGroup, nohscroll, preserveAspect, M7, italic, B65535,  10, fontName, "times";
	fontset = header, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  12, fontName, "times";
	fontset = leftheader,  12, fontName, "times";
	fontset = footer, inactive, nohscroll, noKeepOnOnePage, preserveAspect, center, M7, italic,  12, fontName, "times";
	fontset = leftfooter,  12, fontName, "times";
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "courier";
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, fontName, "times";paletteColors = 128; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
GRTensorM
:[font = subtitle; inactive; preserveAspect]
Getting Started
:[font = text; inactive; preserveAspect]
This notebook introduces the basic GRTensorM commands and stresses the importance of simplification routines.

You must install GRTensorM (see  install.txt) before this example will run.
:[font = section; inactive; preserveAspect; startGroup]
Loading the Package
:[font = text; inactive; preserveAspect]
The following command loads GRTensorM.
:[font = input; preserveAspect; startGroup]
<<grii/grt.m
:[font = print; inactive; preserveAspect; endGroup]
 GRTensorM Version 1.0
 June 4, 1996

 Copyright 1996 by P. Musgrave, D. Pollney and K. Lake
 Use qload[] or grload[] to load a metric.
 ?grtensor for help.

 Metric directory = "/homes/gert/grtensor/mma/metrics/"
:[font = text; inactive; preserveAspect]
The above metric directory should point to the metrics/  directory provided with GRTensorM. If it does not then edit the path in the following command to correct it before proceeding. The trailing slash  is vital (note forward slashes are used even on PCs).
:[font = input; preserveAspect; startGroup]
SetOptions[grii,MetricPath->"/homes/gert/grtensor/mma/metrics/"]
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
{DisplayLimit -> 5000, TimeStamp -> True, 
 
  DefaultSimplification -> Together, Verbose -> True, 
 
  MetricPath -> "/homes/gert/grtensor/mma/metrics/"}
;[o]
{DisplayLimit -> 5000, TimeStamp -> True, 
 
  DefaultSimplification -> Together, Verbose -> True, 
 
  MetricPath -> /homes/gert/grtensor/mma/metrics/}
:[font = section; inactive; preserveAspect; startGroup]
Specifying Spacetimes
:[font = text; inactive; preserveAspect; endGroup]
The examples in this notebook make use of pre-defined spacetimes. The command makeg is used to specify spacetimes. Examples of its use can be found in makeg.txt
:[font = section; inactive; preserveAspect; startGroup]
The Essential Commands
:[font = text; inactive; preserveAspect]
GRTensorII provides commands for the calculation, modification and display of tensor objects. The three most common commands are: grcalc[], grdisplay[] and grmap[]. The arguments to these commands always include the name of a GRTensorM object (or a list of names). 

Scalars are denoted by Mathematica names, e.g. RiemSq for the Kretschman scalar (the full contraction of Riemann with itself). Tensors are denoted by functions and take as many arguments as the object has indices. The type of index is denoted by one of the  placeholder names: up, dn, bup, bdn, cup, cdn, pup and pdn. The up/dn in each placeholder indicates contravariant vs covariant. The prefix 'b' denotes a basis (tetrad) index; 'c' denotes covariant derivative, 'p' a partial derivative. For example the covariant Riemann tensor would be R[dn,dn,dn,dn], a mixed Riemann tensor would be R[dn,dn,up,up], a covariant derivative of Ricci would be R[dn,dn,cdn].  (Note that the covariant Weyl tensor is denoted by Weyl[dn,dn,dn,dn] since C[] is reserved by Mathematica).

A list of the ``essential'' built in objects can be seen online by  ?objects. Additional objects are defined in the cmscalar and NP (Newman-Penrose) libraries. The documentation accompanying the package provides this information in LaTeX form.
:[font = input; preserveAspect; startGroup]
?objects
:[font = print; inactive; preserveAspect; endGroup]
>  Help for: GRTensorM Objects
>
>   We provide here a list of the 'basic' GRTensor objects.
>   Different index combinations are automatically produced.
>   e.g. G[up,dn,cdn], R[bdn,bup], R[dn,bup]
>
> GRTensor Name      Object
> ~~~~~~~~~~~~~~~~~~~~~~~~
>
> Chr[dn,dn,dn]         Christoffel symbol (first kind).
>                       Symmetric in first two indices.
> Chr[dn,dn,up]         Christoffel symbol (second kind).
>                       Symmetric in first two indices.
> detg                  determinant of the metric tensor
> dimension             dimension of the metric
> ds                    the line element
> g[dn,dn]              metric tensor
> g[dn,dn,pdn]          derivitive of metric
> g[dn,dn,pdn,pdn]      second derivative of the metric
> G[dn,dn]              Einstein tensor.
> Ricciscalar           Ricci scalar
> RicciSq               full contraction of Ricci with
   itself.
> R[dn,dn]              Ricci tensors
> R[dn,dn,dn,dn]        Riemann tensor
> RiemSq                full contraction of Riemann with
   itself
> S[dn,dn]              trace-free Ricci tensor
> Weyl[dn,dn,dn,dn]     Weyl tensor.
> Weylstar[dn,dn,dn,dn] Dual of the Weyl tensor
>                       (dual in first index pair)
> x[up]                 coordinates
>
> GRTensor also has definitions for the full set of
> Carminati-McLenaghan scalar invariants (J.Math.Phys 32:
   3135)
> and objects used in their definition.

> The invariants have the names Ricciscalar, R1, R2, 
> R3, M1R, M1I, M2R, M2I, M3, M4, M5R, M5I, W1R, W1I, W2R
   and W2I.
> They may be refered to collectivly by the names CM, CMR,
   CMW and CMM.
> The object Weylstar[dn,dn,dn,dn] is used in their
   definition.
>
> In spherical/plane/hyperbolic symmetric spacetimes the set
   of 14
> reduce to a set of 8, known to GRTensorM as CMS. Detailed
> definitions of the objects can be found in grm.tex
>
> Ricci and Weyl scalars in the Newman-Penrose formalism are
   the
> objects RicciSc and WeylSc respectively.
>
> GRTensorM also has definitions for the basis objects
   R[bdn,bdn],
> R[bdn,bdn,bdn,bdn], Weyl[bdn,bdn,bdn,bdn] and
   Weylstar[bdn,bdn,bdn,bdn].
> If R[bdn,bdn] has been calculated then Ricciscalar is
   calculated by
> contracting Ricci in basis form.
>
> Definitions of new objects can be created with grdefine.

:[font = text; inactive; preserveAspect; endGroup]
Objects which differ in index configuration from those listed above are defined and calculated automatically by the package. For example the objects R[up,up] and G[up,dn,cdn] are not listed above, but they can be used as arguments in grcalc[] and they will be calculated by the package. Covariant derivatives can be added to scalars in the obvious way, by refering to e.g. Ricciscalar[cdn].

This automatic index conversion extends to mixed tensor/basis notation as well. If you have an orthogonal frame loaded and you wish to see the Riemann tensor with two basis indices and two tensor indices you can refer to  R[bdn,bdn,dn,dn] in grcalc[] and a definition for this object will be created automatically.

Now that the object nomenclature has been outlined, the best way to see the use of the commands is in a concrete example.
:[font = section; inactive; preserveAspect; startGroup]
Example: Ricci for Kerr
:[font = text; inactive; preserveAspect]
We begin by loading the Kerr metric from a file. This file was created by the GRTensorM command makeg[] which prompts the user for the necessary information to specify a spacetime (see the file makeg.txt ). The metric is loaded by the command qload[]
:[font = input; preserveAspect; startGroup]
qload[kerr]
:[font = print; inactive; preserveAspect; endGroup]
Default metric = kerr
For the kerr metric.
 
Coordinates
  1        2         3         4
 x  = r,  x  = th,  x  = ph,  x  = t
For the kerr metric.
 
Line element

                                   2   2    2        2
   2      2   2    2        2    dr  (r  + a  Cos[th] )
ds   = dth  (r  + a  Cos[th] ) + ---------------------- + 
                                     2            2
                                    a  - 2 m r + r
 
                                                       2
     2            2 m r          4 a dph dt m r Sin[th]
   dt  (-1 + ----------------) - ----------------------- + 
              2    2        2        2    2        2
             r  + a  Cos[th]        r  + a  Cos[th]
 
                               2            2
      2        2   2    2   2 a  m r Sin[th]
   dph  Sin[th]  (a  + r  + -----------------)
                             2    2        2
                            r  + a  Cos[th]
:[font = text; inactive; preserveAspect]
Now calculate the Ricci tensor. By default the status of the calculation is dispayed, this can be suppressed by using the option Verbose->False, as we will demonstrate shortly.
:[font = input; preserveAspect; startGroup]
grcalc[R[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the kerr metric.
Calculated g[up, up]( 3.25 sec.)
Calculated g[dn, dn, pdn]( 0.85 sec.)
Calculated Chr[dn, dn, dn]( 1.11667 sec.)
Calculated Chr[dn, dn, up]( 3.93333 sec.)
Calculated R[dn, dn]( 16.3 sec.)
CPU Time = 25.7167 sec.
:[font = text; inactive; preserveAspect]
GRTensorM recognized that before it could calculate Ricci there were other objects which had to be calculated first. As it calculated these it indicated the status of the calculation, so you could see what it was up to. Objects will only be calculated once for a given metric. Intermediate objects can be displayed with grdisplay[].

Now we can examine the output with the command grdisplay[]
:[font = input; preserveAspect; startGroup]
grdisplay[R[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the kerr metric.
 
Covariant Ricci
R      = 22764 bytes. Exceeds DisplayLimit
   r r
R       = 14768 bytes. Exceeds DisplayLimit
   r th
R        = 21828 bytes. Exceeds DisplayLimit
   th th
R        = 15228 bytes. Exceeds DisplayLimit
   ph ph
R       = 10564 bytes. Exceeds DisplayLimit
   ph t
R      = 9224 bytes. Exceeds DisplayLimit
   t t
:[font = input; preserveAspect]

:[font = text; inactive; preserveAspect]
First, note that grdisplay[] displays components only up to symmetry (e.g. R th r does not appear). Secondly, only those components which are non-zero are displayed. Finally, if the components are large only their size is displayed. The limit can be changed by using DisplayLimit->newValue (newValue an integer) as a second parameter to grdisplay.

Of course, we know Kerr is vacuum. GRTensorM has not determined that because the expressions require trigonometric simplification before they will reduce to zero. We apply this by using  grmap[] to map a Mathematica routine which performs this simplification. Here we use Together[] with the option Trig->True.
:[font = text; inactive; preserveAspect]
grmap is analagous to Mathematica's Map command. The first argument is the name of a function, or an implicit function with # in the argument slot where the tensor component should go and & to denote the end of the function. In this case we use:
:[font = input; preserveAspect; startGroup]
grmap[Together[#,Trig->True]&, R[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the kerr metric.
Applying Together[#1, Trig -> True] &  to R[dn, dn]
CPU Time = 7.45 sec.
:[font = text; inactive; preserveAspect]
After doing this we see the expected result.
:[font = input; preserveAspect; startGroup]
grdisplay[R[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the kerr metric.
 
Covariant Ricci
R[dn, dn] = All components are zero
:[font = subsubsection; inactive; preserveAspect; startGroup]
Retrieving values
:[font = text; inactive; preserveAspect]
The output of grdisplay[] is not "live" (i.e. you cannot grab it with %) because we prefer to present labeled components instead of a list. A list of the components up to symmetry can be retrieved with grlist[] as follows:
:[font = input; preserveAspect; startGroup]
grlist[g[dn,dn]]
:[font = output; output; inactive; preserveAspect; endGroup]
{(r^2 + a^2*Cos[th]^2)/(a^2 - 2*m*r + r^2), 0, 0, 0, 
 
  r^2 + a^2*Cos[th]^2, 0, 0, 
 
  Sin[th]^2*(a^2 + r^2 + 
 
     (2*a^2*m*r*Sin[th]^2)/(r^2 + a^2*Cos[th]^2)), 
 
  (-2*a*m*r*Sin[th]^2)/(r^2 + a^2*Cos[th]^2), 
 
  -1 + (2*m*r)/(r^2 + a^2*Cos[th]^2)}
;[o]
  2    2        2
 r  + a  Cos[th]             2    2        2
{----------------, 0, 0, 0, r  + a  Cos[th] , 0, 0, 
  2            2
 a  - 2 m r + r
 
                         2            2
         2   2    2   2 a  m r Sin[th]
  Sin[th]  (a  + r  + -----------------), 
                       2    2        2
                      r  + a  Cos[th]
 
                  2
  -2 a m r Sin[th]             2 m r
  -----------------, -1 + ----------------}
   2    2        2         2    2        2
  r  + a  Cos[th]         r  + a  Cos[th]
:[font = text; inactive; preserveAspect]
Simplifying/changing this list will in no way affect GRTensorM's copy of the components of the object. In general you should use grmap to act on GRTensor objects.

A single component can be extracted with grcomponent. For example
:[font = input; preserveAspect; startGroup]
grcomponent[g[dn,dn],{ph,t}]
:[font = output; output; inactive; preserveAspect; endGroup; endGroup; endGroup]
(-2*a*m*r*Sin[th]^2)/(r^2 + a^2*Cos[th]^2)
;[o]
                2
-2 a m r Sin[th]
-----------------
 2    2        2
r  + a  Cos[th]
:[font = section; inactive; preserveAspect; startGroup]
Controlling Simplification is Crucial
:[font = text; inactive; preserveAspect]
Understanding and controlling the simplification during and after calculations is essential. A careful choice of simplification can result in order of magnitude changes in the time to calculate objects in GRTensorM.

By default GRTensorM applies Together[] (with Trig->False) to every component of every object. This has proven to be a reasonable choice.The time required for simplification/modification is generally an exponential function of the input expression size, hence it pays to attempt to keep expressions short. However, it is not normally prudent to simplify maximally, since routines which look for all possible simplifications  (e.g.  Simplify[]) can be very slow. Together has proven to be a good compromise. If there are cases where you suspect further simplification will occur then it is often worth trying. For example if you expect Ricci to have a simple form, you should simplify it before calculating, say scalars which are quadratic in Ricci (e.g. R3).

The name of the default simplification routine is one of the options of the GRTensorM package. If you wish to change the default simplification for a given session use Mathematica's SetOptions[](see the metric path example at the start of this notebook). To change the default simplification during a given calculation use a DefaultSimplfication-> rule (e.g. DefaultSimplification->Factor as an additional parameter to grcalc[].
:[font = subsection; inactive; preserveAspect; startGroup]
Avoid Trigonometric Functions
:[font = text; inactive; preserveAspect]
Trigonometric functions in spacetimes should be avoided whenever possible. The speed of routines like Together depends on the number of unknowns in an expression. Each trig function is interpreted as a new unknown, so replacing them (when possible) can result in significant improvement. 

Consider the Kerr metric. We use an alternate form in which the coordinate transformation u = a Cos[theta] has been performed, and again calculate the Ricci tensor.
:[font = input; preserveAspect; startGroup]
qload[newkerr]
:[font = print; inactive; preserveAspect; endGroup]
Default metric = newkerr
For the newkerr metric.
 
Coordinates
  1        2        3         4
 x  = r,  x  = u,  x  = ph,  x  = t
For the newkerr metric.
 
Line element

                       2    2       2   2    2
   2   -4 dph dt m r (a  - u )    dr  (r  + u )
ds   = ----------------------- + --------------- + 
                 2    2           2            2
             a (r  + u )         a  - 2 m r + r
 
     2   2    2
   du  (r  + u )     2        2 m r
   ------------- + dt  (-1 + -------) + 
       2    2                 2    2
      a  - u                 r  + u
 
                                     2    2
      2   2    2    2    2   2 m r (a  - u )
   dph  (a  - u ) (a  + r  + ---------------)
                                  2    2
                                 r  + u
   ------------------------------------------
                        2
                       a
:[font = input; preserveAspect; startGroup]
grcalc[R[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the newkerr metric.
Calculated g[up, up]( 3.25 sec.)
Calculated g[dn, dn, pdn]( 0.566667 sec.)
Calculated Chr[dn, dn, dn]( 0.566667 sec.)
Calculated Chr[dn, dn, up]( 1.48333 sec.)
Calculated R[dn, dn]( 3.75 sec.)
CPU Time = 9.91667 sec.
:[font = input; preserveAspect; startGroup]
grdisplay[R[dn,dn]]
:[font = print; inactive; preserveAspect; endGroup]
For the newkerr metric.
 
Covariant Ricci
R[dn, dn] = All components are zero
:[font = text; inactive; preserveAspect]
By eliminating the trigonometric functions we have reduced the time to determine Ricci = 0 by a factor of three. As we proceed to calculate more complex objects the speed up can be even more significant. For example:
:[font = input; preserveAspect; startGroup]
grcalc[RiemSq]
:[font = print; inactive; preserveAspect; endGroup]
For the newkerr metric.
Calculated R[dn, dn, dn, dn]( 6.86667 sec.)
Calculated R[up, up, dn, dn]( 4.45 sec.)
Calculated RiemSq( 1.11667 sec.)
CPU Time = 12.6833 sec.
:[font = input; preserveAspect; startGroup]
grdisplay[RiemSq]
:[font = print; inactive; preserveAspect; endGroup]
For the newkerr metric.
 
Full Contraction of Riemann

          2  6       2  4  2       2  2  4    2  6
     48 (m  r  - 15 m  r  u  + 15 m  r  u  - m  u )
K  = ----------------------------------------------
                         2    2 6
                       (r  + u )
:[font = text; inactive; preserveAspect]
takes only one tenth of the time of that for the kerr spactime. If we wish to reinsert the trig. functions we do this via grmap as follows:
:[font = input; preserveAspect; startGroup]
grmap[ReplaceAll[#,u->a Cos[theta]]&, RiemSq]
:[font = print; inactive; preserveAspect; endGroup]
For the newkerr metric.
Applying #1 /. u -> a Cos[theta] &  to RiemSq
CPU Time = 0.0833333 sec.
:[font = input; preserveAspect; startGroup]
grdisplay[RiemSq]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
For the newkerr metric.
 
Full Contraction of Riemann

           2  6       2  2  4           2
K  = (48 (m  r  - 15 a  m  r  Cos[theta]  + 
 
           4  2  2           4    6  2           6
       15 a  m  r  Cos[theta]  - a  m  Cos[theta] )) / 
 
     2    2           2 6
   (r  + a  Cos[theta] )
:[font = subsection; inactive; preserveAspect; startGroup]
Even a little Trig is a bad thing!
:[font = text; inactive; preserveAspect]
The Sin[] function in the radiating Reisner-Nordstrom deSitter metric (radrnds) may seem inocuous, but even in this case there is an advantage to eliminating it. First consider the calculation of the CMS invariants for this space.
:[font = input; preserveAspect; startGroup]
qload[radrnds]
:[font = print; inactive; preserveAspect; endGroup]
Default metric = radrnds
For the radrnds metric.
 
Coordinates
  1        2        3         4
 x  = r,  x  = v,  x  = th,  x  = ph
For the radrnds metric.
 
Line element

   2                2  2
ds   = 2 dr dv + dth  r  + 
 
                2       2
     2       l r    e[v]    2 m[v]       2  2        2
   dv  (-1 + ---- - ----- + ------) + dph  r  Sin[th]
              3       2       r
                     r
:[font = input; preserveAspect; startGroup]
grcalc[CMS]
:[font = message; inactive; preserveAspect]
grii::autoload: 
   Loading objects from grii`objects`cmscalar`CM`
:[font = print; inactive; preserveAspect; endGroup]
Created a definition for S[up, dn]
Created a definition for S[up, up]
Created a definition for Weyl[up, up, up, up]
For the radrnds metric.
Calculated g[up, up]( 0.2 sec.)
Calculated g[dn, dn, pdn]( 0.366667 sec.)
Calculated Chr[dn, dn, dn]( 0.416667 sec.)
Calculated Chr[dn, dn, up]( 0.733333 sec.)
Calculated R[dn, dn]( 0.8 sec.)
Calculated Ricciscalar( 0.0666667 sec.)
Calculated S[dn, dn]( 0.35 sec.)
Calculated S[up, dn]( 0.466667 sec.)
Calculated R1( 0.15 sec.)
Calculated R2( 0.333333 sec.)
Calculated R3( 0.466667 sec.)
Calculated R[dn, dn, dn, dn]( 1.68333 sec.)
Calculated Weyl[dn, dn, dn, dn]( 1.7 sec.)
Calculated Weyl[dn, dn, up, up]( 2.3 sec.)
Calculated WeylSq( 0.266667 sec.)
Calculated W1R( 0.0666667 sec.)
Calculated S[up, up]( 0.65 sec.)
Calculated M1R( 0.7 sec.)
Calculated Weyl[up, up, up, up]( 2.05 sec.)
Calculated M2S( 5.76667 sec.)
Calculated M5S( 18.45 sec.)
CPU Time = 45.2 sec.
:[font = text; inactive; preserveAspect]
Here we use the Verbose->False option to supress the output.
:[font = input; preserveAspect]
grmap[Together[#,Trig->True]&, CMS, Verbose->False]
:[font = input; preserveAspect; startGroup]
grdisplay[CMS]
:[font = print; inactive; preserveAspect; endGroup]
For the radrnds metric.
 
Ricci scalar

R  = 4 l
 
CM invariant R1

          4
      e[v]
R1  = -----
        8
       r
 
CM invariant R2
R2  = 0
 
CM invariant R3

          8
      e[v]
R3  = -----
         16
      4 r
 
CM invariant Re(W1)

              4           2         2     2
       6 (e[v]  - 2 r e[v]  m[v] + r  m[v] )
W1R  = -------------------------------------
                         8
                        r
 
CM invariant Re(M1)

              6         4
       2 (e[v]  - r e[v]  m[v])
M1R  = ------------------------
                  12
                 r
 
CM invariant Re(M2)

              8           6         2     4     2
       4 (e[v]  - 2 r e[v]  m[v] + r  e[v]  m[v] )
M2S  = -------------------------------------------
                            16
                           r
 
CM invariant M5S

               10           8           2     6     2
M5S  = (8 (e[v]   - 3 r e[v]  m[v] + 3 r  e[v]  m[v]  - 
 
        3     4     3      20
       r  e[v]  m[v] )) / r
:[font = text; inactive; preserveAspect]
Now consider the same metric after transforming to u = Sin[th].
:[font = input; preserveAspect; startGroup]
qload[newrrnds]
:[font = print; inactive; preserveAspect; endGroup]
Default metric = newrrnds
For the newrrnds metric.
 
Coordinates
  1        2        3        4
 x  = r,  x  = v,  x  = u,  x  = ph
For the newrrnds metric.
 
Line element

                   2  2
   2             du  r       2  2       2
ds   = 2 dr dv + ------ + dph  r  (1 - u ) + 
                      2
                 1 - u
 
                2       2
     2       l r    e[v]    2 m[v]
   dv  (-1 + ---- - ----- + ------)
              3       2       r
                     r
:[font = input; preserveAspect; startGroup]
grcalc[CMS]
:[font = print; inactive; preserveAspect; endGroup]
For the newrrnds metric.
Calculated g[up, up]( 0.2 sec.)
Calculated g[dn, dn, pdn]( 0.333333 sec.)
Calculated Chr[dn, dn, dn]( 0.383333 sec.)
Calculated Chr[dn, dn, up]( 0.633333 sec.)
Calculated R[dn, dn]( 0.766667 sec.)
Calculated Ricciscalar( 0.0666667 sec.)
Calculated S[dn, dn]( 0.15 sec.)
Calculated S[up, dn]( 0.25 sec.)
Calculated R1( 0.05 sec.)
Calculated R2( 0.1 sec.)
Calculated R3( 0.05 sec.)
Calculated R[dn, dn, dn, dn]( 1.65 sec.)
Calculated Weyl[dn, dn, dn, dn]( 1.25 sec.)
Calculated Weyl[dn, dn, up, up]( 1.75 sec.)
Calculated WeylSq( 0.0666667 sec.)
Calculated W1R( 0.0166667 sec.)
Calculated S[up, up]( 0.4 sec.)
Calculated M1R( 0.183333 sec.)
Calculated Weyl[up, up, up, up]( 1.66667 sec.)
Calculated M2S( 1.93333 sec.)
Calculated M5S( 8.01667 sec.)
CPU Time = 21.25 sec.
:[font = text; inactive; preserveAspect]
We get the same result in less that half the time (even when you include the time to load the CM objects).
:[font = input; preserveAspect; startGroup]
grdisplay[CMS]
:[font = print; inactive; preserveAspect; endGroup; endGroup; endGroup; endGroup]
For the newrrnds metric.
 
Ricci scalar

R  = 4 l
 
CM invariant R1

          4
      e[v]
R1  = -----
        8
       r
 
CM invariant R2
R2  = 0
 
CM invariant R3

          8
      e[v]
R3  = -----
         16
      4 r
 
CM invariant Re(W1)

              4           2         2     2
       6 (e[v]  - 2 r e[v]  m[v] + r  m[v] )
W1R  = -------------------------------------
                         8
                        r
 
CM invariant Re(M1)

              6         4
       2 (e[v]  - r e[v]  m[v])
M1R  = ------------------------
                  12
                 r
 
CM invariant Re(M2)

              8           6         2     4     2
       4 (e[v]  - 2 r e[v]  m[v] + r  e[v]  m[v] )
M2S  = -------------------------------------------
                            16
                           r
 
CM invariant M5S

               10           8           2     6     2
M5S  = (8 (e[v]   - 3 r e[v]  m[v] + 3 r  e[v]  m[v]  - 
 
        3     4     3      20
       r  e[v]  m[v] )) / r
^*)