(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 

Begin["grtG`"]; (* scope for globals variables *)

(*
 * Dummy summation - Some functions which use this involve
 * differentiation, so Release any Hold[]s
 *)

grtF`calcsum0[ object_, iList_] :=
  Return[ ReleaseHold[ ObjDef[object][grtC`calcFnParms] ] ];


(* sum over one index *)

grtF`calcsum1[object_, iList_] :=
Module[ {s},
 s = 0;
 Do[
     s = s + ReleaseHold[ ObjDef[object][grtC`calcFnParms] ],
  { s1, Ndim[metricName]} ];
 Return[s];
]

(* sum over two indices *)

grtF`calcsum2[object_, iList_] :=
Module[ {s},
 s = 0;
 Do[
   Do[
     s = s + ReleaseHold[ ObjDef[object][grtC`calcFnParms] ],
    { s2, Ndim[metricName]}],
 { s1, Ndim[metricName]}];
 Return[s];
]

(* sum over two indices *)
grtF`calcsum3[object_, iList_] :=
Module[ {s},
 s = 0;
 Do[
   Do[
     Do[
       s = s + ReleaseHold[ ObjDef[object][grtC`calcFnParms] ],
     { s3, Ndim[metricName]}],
   { s2, Ndim[metricName]}],
 { s1, Ndim[metricName]}];
 Return[s];
]

(* sum over four indices *)
grtF`calcsum4[object_, iList_] :=
Module[ {s},
 s := 0;
 Do[
   Do[
     Do[
       Do[
	 s = s + ReleaseHold[ ObjDef[object][grtC`calcFnParms] ],
       { s4, Ndim[metricName]}],
     { s3, Ndim[metricName]}],
   { s2, Ndim[metricName]}],
 { s1, Ndim[metricName]}];
 Return[s];
]




End[];


