(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 



grtF`core[ objectName_] :=



Module[ {a, toc, root, calcFn, entry, baseName, symFn},





  If[ grDebug, Print["core: ",objectName] ];



  If[ grtG`calc && grtF`checkIfAssigned[ objectName],

    (*

     * calc-ing gdndn from a basis may call core directly

     * and e[dn,up] may be next in the calc list anyway

     *)
    Return[];

  ];



  toc = TimeUsed[]; (* start the timer *) 





   If[ ValueQ[ grtG`ObjDef[ objectName][grtC`displayName] ],
      baseName = grtG`ObjDef[ objectName][grtC`displayName];

   ,(*else*)

 	baseName = objectName;

   ];

  

  grtG`displayZero = True;    (* global flag set by grtF`components *)



  If[ grtG`fnCode === grtC`display &&

      ValueQ[ grtG`ObjDef[baseName][grtC`header] ] ,

       Write[ grt`stream," "]; (* Whitespace for grsave *)

       Write[ grt`stream, grtG`ObjDef[baseName][grtC`header] ]

  ];



  calcFn = grtG`ObjDef[objectName][grtC`calcFn];

  root = grtG`ObjDef[baseName][grtC`root];







  If[ grtG`calc && ValueQ[grtG`ObjDef[objectName][grtC`preCalcFn]] ,

     grtG`ObjDef[objectName][grtC`preCalcFn][objectName];

  ];





  If[  ValueQ[ grtG`ObjDef[ objectName][grtC`symmetry] ],

      symFn = grtG`ObjDef[objectName][grtC`symmetry];

  ,(*else*)

      symFn = grtG`ObjDef[baseName][grtC`symmetry];

  ];



  If[ NULL =!= symFn[objectName, root, calcFn],

    Write[ grt`stream, grtG`ObjDef[baseName][grtC`symmetry] ,

	   " Internal error: symmetry function did not return NULL"];

  ];







  If[ (grtG`fnCode === grtC`display) && grtG`displayZero ,

    If[ grtG`ObjDef[baseName][grtC`symmetry] === grtF`symscalar ,

       Write[ grt`stream, grtG`ObjDef[objectName][grtC`rootStr], " = 0"]

    ,(*else*)

       Write[ grt`stream, baseName, " = All components are zero"]

    ]

  ];







  If[ grOptionVerbose ,

    If[ grtG`fnCode === grtC`clear ,

	Write[ grt`stream, "Cleared ", baseName," for the ",

		 grtG`metricName, " metric."];

    ]

  ];





 (*

  * CALCULATED MESSAGE

  *)



 If[ grtG`calc,

    grtG`record[grtG`metricName] = Join[grtG`record[grtG`metricName],{baseName}];

   If[ grt`OptionVerbose,

    If[ !grt`OptionTimeStamp,

      Write[ grt`stream, "Calculated ", baseName];

    ,(*else*)

      Write[ grt`stream, "Calculated ", baseName, "( ", TimeUsed[] - toc, " sec.)"];

    ];

   ];

    (* if used additional metric add messages here for GRII *)

 ];



 (*

  * Cleared Message

  *)



 If[ grtG`fnCode === grtC`clear,

      Write[ grt`stream, "Cleared ", objectName];

 ];



 If[ grDebug, Print["Exit core: ", baseName]; ];

 Return[];



] (* end grtF`core[] *)









