(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 

grtF`component[objectName_,indexList_, value_] :=
Module[{size, dispStr, len,i},

   If[ (grtG`fnCode === grtC`display || grtG`fnCode === grtC`alter)
       && value =!= 0,

     (* build a display string with coord names or numbers *)
     dispStr = grtF`dispStr[objectName,indexList];

     size = ByteCount[value];

     Which[
       grtG`fnCode === grtC`alter,
	 (* If simplifying with display (i.e. gralter() call) *)
	 (* display info on the size change realized  *)
	 Write[grt`stream, dispStr," changed to ",size," (bytes)"];
	 grtG`displayZero = False,   (* suppress all component zero msg. *)

       grtG`fnCode === grtC`display ,
	  (* check that size is `reasonable` before printing it. *)
	  grtG`displayZero = False;
	  If[  size < grt`OptionDisplayLimit ,
	     Write[grt`stream,""]; (* whitespace *)
	     Write[grt`stream, dispStr," = ",value];
	  ,(* else *)
	     Write[grt`stream, dispStr," = ",size," bytes. Exceeds DisplayLimit"];
	  ];
     ];
   ];
] (* end grcomponent *)


grtF`dispStr[objectName_,iList_] :=
 Module[{i,index, dispStr},

 dispStr = grtG`ObjDef[objectName][grtC`rootStr];

 Do[
   (*
    * use coord names unless we're displaying
    * coordinates in which case number are mandatory
    *)
   If[ !(objectName === grt`x[up]),
       index = grtG`xup[grtG`metricName, iList[[i]] ]
   ,(*else*)
       index = iList[[i]]
   ];

   Which[ 
     grtG`ObjDef[objectName][grtC`indexList][[i]] === dn,
       index = Subscript[ index ],
     
     grtG`ObjDef[objectName][grtC`indexList][[i]] === up,
       index = Superscript[ index ],
     
     grtG`ObjDef[objectName][grtC`indexList][[i]] === cdn,
       index = Subscript[ StringJoin[ ";", ToString[index] ]],
     
     grtG`ObjDef[objectName][grtC`indexList][[i]] === pdn,
       index = Subscript[ StringJoin[ ",", ToString[index] ]],
     
     
     grtG`ObjDef[objectName][grtC`indexList][[i]] === bdn,
       index = Subscript[ StringJoin[ "(", ToString[index], ")" ]],
     
     grtG`ObjDef[objectName][grtC`indexList][[i]] === cup,
       index = Superscript[ StringJoin[ ";", ToString[index] ]],
     
     grtG`ObjDef[objectName][grtC`indexList][[i]] === pup,
       index = Superscript[ StringJoin[ ",", ToString[index] ]],
     
     grtG`ObjDef[objectName][grtC`indexList][[i]] === bup,
       index = Superscript[ StringJoin[ "(", ToString[index],")" ]]
   ];

   dispStr = SequenceForm[ dispStr, " ", index],

 { i, Length[ iList]}];

 Return[ dispStr];
]; (* end grcDispStr *)





