
grcalc::usage =
"> Help for: grcalc\n\n\
> Calling Sequence: grcalc[ object, options]\n\n\
> Parameters:  object  - a name or list of names indicating GRTensor objects\n\
>              options - grii options or a metric-> specifier\n\
>\n\
> - grcalc calculates the components of objects indicated by <objects>\n\
>   for the default metric. Use of metric-> as an optional parameter\n\
>   allows calculation for non-default metrics.\n\
>\n\
> - during calculation each component is simplified using the default\n\
>   simplification routine. This can be changed by including\n\
<   a DefaultSimplification-> option.\n\
>\n\
> - if any of the objects depend on underlying objects (e.g. Ricci requires\n\
>   Christoffel symbols) then these will be calculated automatically\n\
>\n\
> - if a requested object can be generated from raising/lowering indices\n\
>   of a defined object, an appropriate definition will be generated\n\
>\n\
> Examples:\n\
>\n\
> grcalc[ R[dn,dn] ]\n\
>\n\
> grcalc[ {R[dn,dn], C[dn,dn,dn,dn]}, DefaultSimplification->Factor,\n\
>          metric->rw ]\n"


grclear::usage =
"> Help for: grclear\n\n\
> Calling Sequence: grclear[ object, options]\n\n\
> Parameters:  object  - a name or list of names indicating GRTensor objects\n\
>	       options - (optional) a metric-> specifier\n\
>\n\
> - grclear allows for the calculated value(s) of an object or group of\n\
>   objects to be cleared.\n\
>\n
> - to clear all calculations for a specific metric but not the metric\n\
>   itself use the object name results.\n\
>\n\
> - to clear all results and the metric use the name metric\n"



grcomponent::usage =
"> Help for: grcomponent\n\n\
> Calling Sequence: grcomponent[ object, indexList, options]\n\n\
> Parameters:  object    - a name indicating a GRTensor object\n\
>              indexList - list specifying specific component\n\
>              options   - an optional metric-> specifier\n\
>\n\
> - displays a specific component for a GRTensor object\n\
>\n\
> - either coordinate numbers or names may be used\n\
>\n\
> - only the component value is displayed so that it can be\n\
>   manipulated via the use of % (previous output placeholder)\n\
>\n\
> Examples:\n\
>\n\
> grcomponent[ R[dn,dn,dn,dn], {1,2,1,2}, metric->rw]\n\
>\n\
> grcomponent[ R[dn,dn], {r, theta} ]"

grdefine::usage =
"\
>Help for: grdefine\n\
> Calling Sequence: grdefine[ newObject, symmetry, definition]\n\
> Parameters:  object - tensorString of new object\n\
>              symmetry - name of an existing objects with\n\
>                         the symmetry of newObject or {}\n\
>                         for none.\n\
>              definition - (optional) a tensorString\n\
>                           definition of newObject\n>\n\
> - grdefine allows users to create definitions of new objects\n>\n\
> - both the newObject and (optional) definition must indicate\n\
>   indices by name, and definitions may contain contractions etc.\n\
>   For this reason they are entered as strings. e.g. \"T{^a b ; a}\"\n\
>   tensorStrings make use of the following conventions:\n>\n\
>    - all indices are contained in {}'s\n\
>    - indices are covariant by default\n\
>    - indices prefixed by ^ are contravariant\n\
>    - an index prefixed by $ indicates an explicit\n\
>      coordinate name\n\
>    - indices surrounded by ()'s are basis indices\n\
>    - all indices after a semi-colon are covariant derivatives\n\
>    - all indices after a comma are partial derivatives\n\
>    - () and [] may be used to denote symmetrizations\n\
>      and anti-symmetrization in the definition\n>\n\
> - if no definition is provided GRTensor will prompt for\n\
>   explicit components when the object is calculated\n\
> Examples:\n>\n\
> grdefine[ \"G2{a b}\", g[dn,dn], \"R{a b} - 1/2 R{^c c} g{a b}\"]\n\
    Created defintion for G2[dn,dn]\n\
> grdefine[ \"Killing{a b}\", g[dn,dn], \"tl{ (a ; b) }\"]\n\
    Created definition for Killing[dn,dn]"

grdisplay::usage =
"> Help for: grdisplay\n\n\
> Calling Sequence: grdisplay[ object, options]\n\n\
> Parameters:  object - a name or list of names indicating GRTensor objects\n\
>              options- an integer simplification code and/or a\n\
>                       metric-> specifier\n\
>\n\
> - grdisplay displays the `essential' components of a tensor. Components\n\
>   which are reached by use of symmetry operations are not displayed.\n\
>\n\
> - if all components are zero a message to that effect is printed\n\
>\n\
> - if no metric-> tag is provided then objects from the default metric\n\
>   metric are displayed, otherwise the objects from the metric indicated\n\
>   by the metric rule are displayed\n>\n\
> - if object size exceeds the DisplayLimit option then only the size\n\
>   will be displayed. This can be increased by providing a\n
>   DisplayLimit-> option.\n\
>\n\
> Examples:\n\
>\n\
> grdisplay[ R[dn,dn] ]\n\
>\n\
> grdisplay[ {R[dn,dn], G[dn,dn]}, metric->vaidya, DisplayLimit->10000 ]\n";

grload::usage =
"> Help for: grload\n\
>\n\
> Calling Sequence: grload[ metricName, file]\n\
>\n\
> Parameters:  metricName - name to assign to the metric\n\
>              file       - string holding the name of the metric file\n\
>\n\
> - loads the metric from the file indicated by <file> and gives it\n\
>   the name <name>\n\
>\n\
> Examples:\n\
>\n\
> grload[ schw, \"c:\makeg\schw\schw.g\" ]"

grlist::usage = 
grmap::usage =
"> Help for: grlist\n>\n\
> Calling Sequence: grlist[ object]\n\
>\n\
> Parameters:  object  - a GRTensorII object name\n>\n\
> - returns the primary components of an object (i.e up to\n\
>   symmetry) as a list"

grmap::usage =
"> Help for: grmap\n\
>\n\
> Calling Sequence: grmap[ function, objects, options]\n\
>\n\
> Parameters:  function - function to apply to objects\n\
>              objects  - a name or list of names indicating\n\
>                         GRTensor objects\n\
>              options  - options to be passed to function\n\
>\n\
> - applies <function> to each component of the objects listed in\n\
>   <objects>.\n\
>\n\
> - grmap automatically acts on the default metric.\n\
>\n\
> - if the function to be mapped takes only a single parameter\n\
>   only the function name is required in <function>\n\
>\n\
> - functions with multiple parameters are specified in the form\n\
>      FunctionName[#, parm2, parm3]&\n\
>   where the # is a placeholder for the component value and the\n\
>   & terminates the function definition.\n\
>\n\
> - for a list of potentially useful simplification functions\n\
>   try ?grsimp\n\
>\n\
> Examples:\n\
>\n\
> grmap[ Factor[#, Trig->True]&, G[dn,dn] ]\n\
>\n\
> grmap[ Simplify, {R[up,dn], C[dn,dn,dn,dn]}, metric->tosa]"

grsimp::usage = 
"> Help for: general simplification hints\n\
>\n\
> grmap can be used to apply a Mathematica simplification/modification\n\
> function to the components of an object. We list here a summary of\n\
> simplification commands we often find useful. (The column Trig\n\
> indicates the command allows a Trig->True option for trigonometric\n\
> simplification.)\n\
>\n\
>     Command   Trig  Comment\n\
>  ------------------------------------------\n\
>     Together    Y    Good general purpose term collection\n\
>     Expand      Y    expand out products\n\
>     Factor      Y    collect common sub-expressions\n\
>     PowerExpand N    expand out Power[] functions
>     Simplify    Y    try a variety of simplifications\n\
>                      (this is useful, but can be *slow*)\n\
>     ApplyConstraints (defined by GRTensorM) applies the constraints\n\
>                      provided in the metric file\n\
>\n\
>  Refer to the Mathematica manual for details on these and other\n\
>  simplification routines.\n\
>\n"
               
grmetric::usage =
"> Help for: grmetric\n\
>\n\
> Calling Sequence: grmetric[ newMetric]\n\
>\n\
> Parameters:  newMetric - name of the new default metric.\n\
>\n\
> - changes the default metric to <newMetric>"

qload::usage =
"> Help for: qload\n\n\
> Calling Sequence: qload[metric]\n\
>\n\
> Parameters:  metric - a metric name\n\
>\n\
> - loads a metric from the file <metric>.g from the directory\n\
>   specified by the MetricPath option variable and assigns it\n\
>   the name <metric>."


grtensor::usage =
"> Help for: The GRTensorM package\n\
>\n\
> GRTensor allows calculation in component, basis and NP formalisms\n\
> for user defined spaces of variable dimension.\n\
>\n\
> It consists of the following functions:\n\
>\n\
> grcalc        calculate tensors/scalars\n\
> grclear       clear objects, all results or the metric\n\
> grcomponent   display a single component of a tensor\n\
> grdisplay     display tensors/scalars\n\
> grdefine      define a new object\n\
> grlist        return values of a tensor as a list\n\
> grload        load a metric from a file\n\
> grmap         apply a function to tensors/scalars\n\
> grmetric      change the default metric\n\
> qload         quick loading of a metric\n\
>\n\
> GRTensor object names generally conform with the usual\n\
> nomenclature. Index configuration is indicated by the use\n\
> of the index names up, dn, bup, bdn, cup, cdn, pup, pdn.\n\
> up denotes contravariant, dn covariant. The prefix `b` indicates\n\
> a basis index, `c` a covariant derivative and `p` a partial\n\ 
> derivative For example the metric tensor is: g[dn,dn].\n\
> Weyl is represented by Weyl[dn,dn,dn,dn] to avoid conflict\n\
> with the Mathematica's  C[].\n\
>\n\
> For a full list of GRTensor objects do ?objects"


objects::usage=
">  Help for: GRTensorM Objects\n\
>\n\
>   We provide here a list of the 'basic' GRTensor objects.\n\
>   Different index combinations are automatically produced.\n\
>   e.g. G[up,dn,cdn], R[bdn,bup], R[dn,bup]\n\
>\n\
> GRTensor Name      Object\n\
> ~~~~~~~~~~~~~~~~~~~~~~~~\n>\n\
> Chr[dn,dn,dn]         Christoffel symbol (first kind).\n\
>                       Symmetric in first two indices.\n\
> Chr[dn,dn,up]         Christoffel symbol (second kind).\n\
>                       Symmetric in first two indices.\n\
> detg                  determinant of the metric tensor\n\
> dimension             dimension of the metric\n\
> ds                    the line element\n\
> g[dn,dn]              metric tensor\n\
> g[dn,dn,pdn]          derivitive of metric\n\
> g[dn,dn,pdn,pdn]      second derivative of the metric\n\
> G[dn,dn]              Einstein tensor.\n\
> Ricciscalar           Ricci scalar\n\
> RicciSq               full contraction of Ricci with itself.\n\
> R[dn,dn]              Ricci tensors\n\
> R[dn,dn,dn,dn]        Riemann tensor\n\
> RiemSq                full contraction of Riemann with itself\n\
> S[dn,dn]              trace-free Ricci tensor\n\
> Weyl[dn,dn,dn,dn]     Weyl tensor.\n\
> Weylstar[dn,dn,dn,dn] Dual of the Weyl tensor\n\
>                       (dual in first index pair)\n\
> x[up]                 coordinates\n\
>\n\
> GRTensor also has definitions for the full set of\n\
> Carminati-McLenaghan scalar invariants (J.Math.Phys 32: 3135)\n\
> and objects used in their definition.\n\n\
> The invariants have the names Ricciscalar, R1, R2, \n\
> R3, M1R, M1I, M2R, M2I, M3, M4, M5R, M5I, W1R, W1I, W2R and W2I.\n\
> They may be refered to collectivly by the names CM, CMR, CMW and CMM.\n\
> The object Weylstar[dn,dn,dn,dn] is used in their definition.\n\
>\n\
> In spherical/plane/hyperbolic symmetric spacetimes the set of 14\n\
> reduce to a set of 8, known to GRTensorM as CMS. Detailed\n\
> definitions of the objects can be found in grm.tex\n\
>\n\
> Ricci and Weyl scalars in the Newman-Penrose formalism are the\n\
> objects RicciSc and WeylSc respectively.\n\
>\n\
> GRTensorM also has definitions for the basis objects R[bdn,bdn],\n\
> R[bdn,bdn,bdn,bdn], Weyl[bdn,bdn,bdn,bdn] and Weylstar[bdn,bdn,bdn,bdn].\n\
> If R[bdn,bdn] has been calculated then Ricciscalar is calculated by\n\
> contracting Ricci in basis form.\n\
>\n\
> Definitions of new objects can be created with grdefine.\n\
"

PetrovReport::usage=
" Help for: PetrovReport\n>\n\
> Calling Sequence: PetrovReport[]\n>\n\
> - PetrovReport indicates the intermediate quantities which\n\
>   were used in the determination of Petrov type performed by\n\
>   calculating Petrov for a NP tetrad.\n>\n\
> - Petrov type determination is based on attempting to reduce\n\
>   certain quantities to zero. Depending on the simplification used\n\
>   there may exist quantities which are in fact zero but could not\n\
>   be reduced to zero with the default simplification. PetrovReport\n\
>   allows the user to inspect these quantities."
