(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 

Begin["grtG`"];

(* ----------------------------- *)
(*  NP spin coefficient: kappa *)
(* ----------------------------- *)
 ObjDef[grt`Ckappa][grtC`header] = "NP Spin Coefficient, kappa";
 ObjDef[grt`Ckappa][grtC`root] = grtG`NPkappa;
 ObjDef[grt`Ckappa][grtC`rootStr] = "kappa";
 ObjDef[grt`Ckappa][grtC`indexList] = {};
 ObjDef[grt`Ckappa][grtC`calcFn] = grtF`calcCkappa;
 ObjDef[grt`Ckappa][grtC`calcFnParms] = {};
 ObjDef[grt`Ckappa][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Ckappa][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };
grtF`calcCkappa[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) 
		For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,3,k]*
		 ebdndn[metricName,1,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: sigma *)
(* ----------------------------- *)
 ObjDef[grt`Csigma][grtC`header] = "NP Spin Coefficient, sigma";
 ObjDef[grt`Csigma][grtC`root] = grtG`NPsigma;
 ObjDef[grt`Csigma][grtC`rootStr] = "sigma";
 ObjDef[grt`Csigma][grtC`indexList] = {};
 ObjDef[grt`Csigma][grtC`calcFn] = grtF`calcCsigma;
 ObjDef[grt`Csigma][grtC`calcFnParms] = {};
 ObjDef[grt`Csigma][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Csigma][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };
grtF`calcCsigma[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) 
	      For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) 
		For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,1,k]*
		ebdndn[metricName,3,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: lambda *)
(* ----------------------------- *)
 ObjDef[grt`Clambda][grtC`header] = "NP Spin Coefficient, lambda";
 ObjDef[grt`Clambda][grtC`root] = grtG`NPlambda;
 ObjDef[grt`Clambda][grtC`rootStr] = "lambda";
 ObjDef[grt`Clambda][grtC`indexList] = {};
 ObjDef[grt`Clambda][grtC`calcFn] = grtF`calcClambda;
 ObjDef[grt`Clambda][grtC`calcFnParms] = {};
 ObjDef[grt`Clambda][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Clambda][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcClambda[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) 
	      For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) 
		For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,2,k]*
		ebdndn[metricName,4,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: nu *)
(* ----------------------------- *)
 ObjDef[grt`Cnu][grtC`header] = "NP Spin Coefficient, nu";
 ObjDef[grt`Cnu][grtC`root] = grtG`NPnu;
 ObjDef[grt`Cnu][grtC`rootStr] = "nu";
 ObjDef[grt`Cnu][grtC`indexList] = {};
 ObjDef[grt`Cnu][grtC`calcFn] = grtF`calcCnu;
 ObjDef[grt`Cnu][grtC`calcFnParms] = {};
 ObjDef[grt`Cnu][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cnu][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCnu[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) 
	      For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) 
		For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,4,k]*
		ebdndn[metricName,2,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: rho *)
(* ----------------------------- *)
 ObjDef[grt`Crho][grtC`header] = "NP Spin Coefficient, rho";
 ObjDef[grt`Crho][grtC`root] = grtG`NPrho;
 ObjDef[grt`Crho][grtC`rootStr] = "rho";
 ObjDef[grt`Crho][grtC`indexList] = {};
 ObjDef[grt`Crho][grtC`calcFn] = grtF`calcCrho;
 ObjDef[grt`Crho][grtC`calcFnParms] = {};
 ObjDef[grt`Crho][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Crho][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCrho[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) 
	      For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) 
		For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
		ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,1,l] -
		ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,1,l] +
		ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,1,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: mu *)
(* ----------------------------- *)
 ObjDef[grt`Cmu][grtC`header] = "NP Spin Coefficient, mu";
 ObjDef[grt`Cmu][grtC`root] = grtG`NPmu;
 ObjDef[grt`Cmu][grtC`rootStr] = "mu";
 ObjDef[grt`Cmu][grtC`indexList] = {};
 ObjDef[grt`Cmu][grtC`calcFn] = grtF`calcCmu;
 ObjDef[grt`Cmu][grtC`calcFnParms] = {};
 ObjDef[grt`Cmu][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cmu][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCmu[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) 
	      For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) 
		For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,2,l] +
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,2,l] -
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,2,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: tau *)
(* ----------------------------- *)
 ObjDef[grt`Ctau][grtC`header] = "NP Spin Coefficient, tau";
 ObjDef[grt`Ctau][grtC`root] = grtG`NPtau;
 ObjDef[grt`Ctau][grtC`rootStr] = "tau";
 ObjDef[grt`Ctau][grtC`indexList] = {};
 ObjDef[grt`Ctau][grtC`calcFn] = grtF`calcCtau;
 ObjDef[grt`Ctau][grtC`calcFnParms] = {};
 ObjDef[grt`Ctau][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Ctau][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCtau[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,3,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,3,l] -
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,3,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: pi *)
(* ----------------------------- *)
 ObjDef[grt`Cpi][grtC`header] = "NP Spin Coefficient, pi";
 ObjDef[grt`Cpi][grtC`root] = grtG`NPpi;
 ObjDef[grt`Cpi][grtC`rootStr] = "pi";
 ObjDef[grt`Cpi][grtC`indexList] = {};
 ObjDef[grt`Cpi][grtC`calcFn] = grtF`calcCpi;
 ObjDef[grt`Cpi][grtC`calcFnParms] = {};
 ObjDef[grt`Cpi][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cpi][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCpi[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,4,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,4,l] +
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,4,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: epsilon *)
(* ----------------------------- *)
 ObjDef[grt`Cepsilon][grtC`header] = "NP Spin Coefficient, epsilon";
 ObjDef[grt`Cepsilon][grtC`root] = grtG`NPepsilon;
 ObjDef[grt`Cepsilon][grtC`rootStr] = "epsilon";
 ObjDef[grt`Cepsilon][grtC`indexList] = {};
 ObjDef[grt`Cepsilon][grtC`calcFn] = grtF`calcCepsilon;
 ObjDef[grt`Cepsilon][grtC`calcFnParms] = {};
 ObjDef[grt`Cepsilon][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cepsilon][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCepsilon[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
                If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,4,l] -
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,4,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (detb[metricName]*s + NPrho[metricName])/2;
	Return[s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: gamma *)
(* ----------------------------- *)
 ObjDef[grt`Cgamma][grtC`header] = "NP Spin Coefficient, gamma";
 ObjDef[grt`Cgamma][grtC`root] = grtG`NPgamma;
 ObjDef[grt`Cgamma][grtC`rootStr] = "gamma";
 ObjDef[grt`Cgamma][grtC`indexList] = {};
 ObjDef[grt`Cgamma][grtC`calcFn] = grtF`calcCgamma;
 ObjDef[grt`Cgamma][grtC`calcFnParms] = {};
 ObjDef[grt`Cgamma][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cgamma][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCgamma[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,3,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,3,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (detb[metricName]*s + NPmu[metricName])/2;
	Return[s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: alpha *)
(* ----------------------------- *)
 ObjDef[grt`Calpha][grtC`header] = "NP Spin Coefficient, alpha";
 ObjDef[grt`Calpha][grtC`root] = grtG`NPalpha;
 ObjDef[grt`Calpha][grtC`rootStr] = "alpha";
 ObjDef[grt`Calpha][grtC`indexList] = {};
 ObjDef[grt`Calpha][grtC`calcFn] = grtF`calcCalpha;
 ObjDef[grt`Calpha][grtC`calcFnParms] = {};
 ObjDef[grt`Calpha][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Calpha][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCalpha[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,1,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,1,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (detb[metricName]*s + NPpi[metricName])/2;
	Return[s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: beta *)
(* ----------------------------- *)
 ObjDef[grt`Cbeta][grtC`header] = "NP Spin Coefficient, beta";
 ObjDef[grt`Cbeta][grtC`root] = grtG`NPbeta;
 ObjDef[grt`Cbeta][grtC`rootStr] = "beta";
 ObjDef[grt`Cbeta][grtC`indexList] = {};
 ObjDef[grt`Cbeta][grtC`calcFn] = grtF`calcCbeta;
 ObjDef[grt`Cbeta][grtC`calcFnParms] = {};
 ObjDef[grt`Cbeta][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cbeta][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCbeta[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,2,l] -
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,2,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (detb[metricName]*s + NPtau[metricName])/2;
	Return[s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  The following set of obects are complex conjugates *)
(*  of the D-spin coefficients defined above. They are *)
(*  obtained from the above objects by interchanging *)
(*  3's a2 3's in the i2ices. *)
(* ----------------------------- *)

(* ----------------------------- *)
(*  NP spin coefficient: kappabar *)
(* ----------------------------- *)
 ObjDef[grt`Ckappabar][grtC`header] = "NP Spin Coefficient, kappabar";
 ObjDef[grt`Ckappabar][grtC`root] = grtG`NPkappabar;
 ObjDef[grt`Ckappabar][grtC`rootStr] = "kappabar";
 ObjDef[grt`Ckappabar][grtC`indexList] = {};
 ObjDef[grt`Ckappabar][grtC`calcFn] = grtF`calcCkappabar;
 ObjDef[grt`Ckappabar][grtC`calcFnParms] = {};
 ObjDef[grt`Ckappabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Ckappabar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCkappabar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,4,k]*
			ebdndn[metricName,1,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: sigmabar *)
(* ----------------------------- *)
 ObjDef[grt`Csigmabar][grtC`header] = "NP Spin Coefficient, sigmabar";
 ObjDef[grt`Csigmabar][grtC`root] = grtG`NPsigmabar;
 ObjDef[grt`Csigmabar][grtC`rootStr] = "sigmabar";
 ObjDef[grt`Csigmabar][grtC`indexList] = {};
 ObjDef[grt`Csigmabar][grtC`calcFn] = grtF`calcCsigmabar;
 ObjDef[grt`Csigmabar][grtC`calcFnParms] = {};
 ObjDef[grt`Csigmabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Csigmabar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCsigmabar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,1,k]*
			ebdndn[metricName,4,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: lambdabar *)
(* ----------------------------- *)
 ObjDef[grt`Clambdabar][grtC`header] = "NP Spin Coefficient, lambdabar";
 ObjDef[grt`Clambdabar][grtC`root] = grtG`NPlambdabar;
 ObjDef[grt`Clambdabar][grtC`rootStr] = "lambdabar";
 ObjDef[grt`Clambdabar][grtC`indexList] = {};
 ObjDef[grt`Clambdabar][grtC`calcFn] = grtF`calcClambdabar;
 ObjDef[grt`Clambdabar][grtC`calcFnParms] = {};
 ObjDef[grt`Clambdabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Clambdabar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcClambdabar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,2,k]*
			ebdndn[metricName,3,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: nubar *)
(* ----------------------------- *)
 ObjDef[grt`Cnubar][grtC`header] = "NP Spin Coefficient, nubar";
 ObjDef[grt`Cnubar][grtC`root] = grtG`NPnubar;
 ObjDef[grt`Cnubar][grtC`rootStr] = "nubar";
 ObjDef[grt`Cnubar][grtC`indexList] = {};
 ObjDef[grt`Cnubar][grtC`calcFn] = grtF`calcCnubar;
 ObjDef[grt`Cnubar][grtC`calcFnParms] = {};
 ObjDef[grt`Cnubar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cnubar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCnubar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,3,k]*
			ebdndn[metricName,2,l]*LevCSupupupup[metricName,i,j,k,l];
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: rhobar *)
(* ----------------------------- *)
 ObjDef[grt`Crhobar][grtC`header] = "NP Spin Coefficient, rhobar";
 ObjDef[grt`Crhobar][grtC`root] = grtG`NPrhobar;
 ObjDef[grt`Crhobar][grtC`rootStr] = "rhobar";
 ObjDef[grt`Crhobar][grtC`indexList] = {};
 ObjDef[grt`Crhobar][grtC`calcFn] = grtF`calcCrhobar;
 ObjDef[grt`Crhobar][grtC`calcFnParms] = {};
 ObjDef[grt`Crhobar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Crhobar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCrhobar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,1,l] -
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,1,l] +
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,1,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: mubar *)
(* ----------------------------- *)
 ObjDef[grt`Cmubar][grtC`header] = "NP Spin Coefficient, mubar";
 ObjDef[grt`Cmubar][grtC`root] = grtG`NPmubar;
 ObjDef[grt`Cmubar][grtC`rootStr] = "mubar";
 ObjDef[grt`Cmubar][grtC`indexList] = {};
 ObjDef[grt`Cmubar][grtC`calcFn] = grtF`calcCmubar;
 ObjDef[grt`Cmubar][grtC`calcFnParms] = {};
 ObjDef[grt`Cmubar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cmubar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCmubar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,2,l] +
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,2,l] -
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,2,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP spin coefficient: taubar *)
(* ----------------------------- *)
 ObjDef[grt`Ctaubar][grtC`header] = "NP Spin Coefficient, taubar";
 ObjDef[grt`Ctaubar][grtC`root] = grtG`NPtaubar;
 ObjDef[grt`Ctaubar][grtC`rootStr] = "taubar";
 ObjDef[grt`Ctaubar][grtC`indexList] = {};
 ObjDef[grt`Ctaubar][grtC`calcFn] = grtF`calcCtaubar;
 ObjDef[grt`Ctaubar][grtC`calcFnParms] = {};
 ObjDef[grt`Ctaubar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Ctaubar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCtaubar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,4,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,4,l] -
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,4,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP Spin coefficient: pibar *)
(* ----------------------------- *)
 ObjDef[grt`Cpibar][grtC`header] = "NP Spin Coefficient, pibar";
 ObjDef[grt`Cpibar][grtC`root] = grtG`NPpibar;
 ObjDef[grt`Cpibar][grtC`rootStr] = "pibar";
 ObjDef[grt`Cpibar][grtC`indexList] = {};
 ObjDef[grt`Cpibar][grtC`calcFn] = grtF`calcCpibar;
 ObjDef[grt`Cpibar][grtC`calcFnParms] = {};
 ObjDef[grt`Cpibar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cpibar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCpibar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,3,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,3,l] +
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,3,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	Return[-detb[metricName]*s/2];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP Spin coefficient: epsilonbar *)
(* ----------------------------- *)
 ObjDef[grt`Cepsilonbar][grtC`header] = "NP Spin Coefficient, epsilonbar";
 ObjDef[grt`Cepsilonbar][grtC`root] = grtG`NPepsilonbar;
 ObjDef[grt`Cepsilonbar][grtC`rootStr] = "epsilonbar";
 ObjDef[grt`Cepsilonbar][grtC`indexList] = {};
 ObjDef[grt`Cepsilonbar][grtC`calcFn] = grtF`calcCepsilonbar;
 ObjDef[grt`Cepsilonbar][grtC`calcFnParms] = {};
 ObjDef[grt`Cepsilonbar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cepsilonbar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCepsilonbar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,3,l] -
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,3,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (-detb[metricName]*s + NPrhobar[metricName])/2;
	Return[s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP Spin coefficient: gammabar *)
(* ----------------------------- *)
 ObjDef[grt`Cgammabar][grtC`header] = "NP Spin Coefficient, gammabar";
 ObjDef[grt`Cgammabar][grtC`root] = grtG`NPgammabar;
 ObjDef[grt`Cgammabar][grtC`rootStr] = "gammabar";
 ObjDef[grt`Cgammabar][grtC`indexList] = {};
 ObjDef[grt`Cgammabar][grtC`calcFn] = grtF`calcCgammabar;
 ObjDef[grt`Cgammabar][grtC`calcFnParms] = {};
 ObjDef[grt`Cgammabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cgammabar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCgammabar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,4,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,4,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (-detb[metricName]*s + NPmubar[metricName])/2;
	Return[s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP Spin coefficient: alphabar *)
(* ----------------------------- *)
 ObjDef[grt`Calphabar][grtC`header] = "NP Spin Coefficient, alphabar";
 ObjDef[grt`Calphabar][grtC`root] = grtG`NPalphabar;
 ObjDef[grt`Calphabar][grtC`rootStr] = "alphabar";
 ObjDef[grt`Calphabar][grtC`indexList] = {};
 ObjDef[grt`Calphabar][grtC`calcFn] = grtF`calcCalphabar;
 ObjDef[grt`Calphabar][grtC`calcFnParms] = {};
 ObjDef[grt`Calphabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Calphabar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCalphabar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,3,i,j]*ebdndn[metricName,2,k]*ebdndn[metricName,1,l] -
			ebdndnpdn[metricName,2,i,j]*ebdndn[metricName,3,k]*ebdndn[metricName,1,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (-detb[metricName]*s + NPpibar[metricName])/2;
	Return[s];
]; (* e2 Module *)

(* ----------------------------- *)
(*  NP Spin coefficient: betabar *)
(* ----------------------------- *)
 ObjDef[grt`Cbetabar][grtC`header] = "NP Spin Coefficient, betabar";
 ObjDef[grt`Cbetabar][grtC`root] = grtG`NPbetabar;
 ObjDef[grt`Cbetabar][grtC`rootStr] = "betabar";
 ObjDef[grt`Cbetabar][grtC`indexList] = {};
 ObjDef[grt`Cbetabar][grtC`calcFn] = grtF`calcCbetabar;
 ObjDef[grt`Cbetabar][grtC`calcFnParms] = {};
 ObjDef[grt`Cbetabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Cbetabar][grtC`depends] = { grt`detb, grt`LevCS[up,up,up,up], 
	grt`e[bdn,dn], grt`e[bdn,dn,pdn] };

grtF`calcCbetabar[ object_,index_] :=
Module[ { i,j,k,l,s},
	s = 0;
	For[ i = 1, i <=  Ndim[metricName] , i++ ,
	  For[ j = 1, j <=  Ndim[metricName] , j++ ,
	    If[ j=!=i , (* then *) For[ k = 1, k <=  Ndim[metricName] , k++ ,
	      If[ k=!=i && k=!=j , (* then *) For[ l = 1, l <=  Ndim[metricName] , l++ ,
	        If[ l=!=i && l=!=j && l=!=k , (* then *)
	          s = s + LevCSupupupup[metricName,i,j,k,l]*(
			ebdndnpdn[metricName,1,i,j]*ebdndn[metricName,4,k]*ebdndn[metricName,2,l] -
			ebdndnpdn[metricName,4,i,j]*ebdndn[metricName,1,k]*ebdndn[metricName,2,l] );
	        ]; (* e2 If *)
	      ];]; (* e2 If *)
	    ];]; (* e2 If *)
	  ]; (* e2 For *)
	]; (* e2 For *)
	s = (-detb[metricName]*s + NPtaubar[metricName])/2;
	Return[s];
]; (* e2 Module *)

End[];

