(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 

Begin["grtG`"];


(* ----------------------------- *)
(*  NP spin coefficient: kappa *)
(* ----------------------------- *)
 ObjDef[grt`NPkappa][grtC`header] = "NP Spin Coefficient, kappa";
 ObjDef[grt`NPkappa][grtC`root] = grtG`NPkappa;
 ObjDef[grt`NPkappa][grtC`rootStr] = "kappa";
 ObjDef[grt`NPkappa][grtC`indexList] = {};
 ObjDef[grt`NPkappa][grtC`calcFn] = grtF`calcNPkappa;
 ObjDef[grt`NPkappa][grtC`calcFnParms] = {};
 ObjDef[grt`NPkappa][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPkappa][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPkappa [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,3,1,1];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: sigma *)
(* ----------------------------- *)
 ObjDef[grt`NPsigma][grtC`header] = "NP Spin Coefficient, sigma";
 ObjDef[grt`NPsigma][grtC`root] = grtG`NPsigma;
 ObjDef[grt`NPsigma][grtC`rootStr] = "sigma";
 ObjDef[grt`NPsigma][grtC`indexList] = {};
 ObjDef[grt`NPsigma][grtC`calcFn] = grtF`calcNPsigma;
 ObjDef[grt`NPsigma][grtC`calcFnParms] = {};
 ObjDef[grt`NPsigma][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPsigma][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPsigma [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,3,1,3];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: lambda *)
(* ----------------------------- *)
 ObjDef[grt`NPlambda][grtC`header] = "NP Spin Coefficient, lambda";
 ObjDef[grt`NPlambda][grtC`root] = grtG`NPlambda;
 ObjDef[grt`NPlambda][grtC`rootStr] = "lambda";
 ObjDef[grt`NPlambda][grtC`indexList] = {};
 ObjDef[grt`NPlambda][grtC`calcFn] = grtF`calcNPlambda;
 ObjDef[grt`NPlambda][grtC`calcFnParms] = {};
 ObjDef[grt`NPlambda][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPlambda][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPlambda [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,4,4];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: nu *)
(* ----------------------------- *)
 ObjDef[grt`NPnu][grtC`header] = "NP Spin Coefficient, nu";
 ObjDef[grt`NPnu][grtC`root] = grtG`NPnu;
 ObjDef[grt`NPnu][grtC`rootStr] = "nu";
 ObjDef[grt`NPnu][grtC`indexList] = {};
 ObjDef[grt`NPnu][grtC`calcFn] = grtF`calcNPnu;
 ObjDef[grt`NPnu][grtC`calcFnParms] = {};
 ObjDef[grt`NPnu][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPnu][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPnu [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,4,2];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: rho *)
(* ----------------------------- *)
 ObjDef[grt`NPrho][grtC`header] = "NP Spin Coefficient, rho";
 ObjDef[grt`NPrho][grtC`root] = grtG`NPrho;
 ObjDef[grt`NPrho][grtC`rootStr] = "rho";
 ObjDef[grt`NPrho][grtC`indexList] = {};
 ObjDef[grt`NPrho][grtC`calcFn] = grtF`calcNPrho;
 ObjDef[grt`NPrho][grtC`calcFnParms] = {};
 ObjDef[grt`NPrho][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPrho][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPrho [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,3,1,4];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: mu *)
(* ----------------------------- *)
 ObjDef[grt`NPmu][grtC`header] = "NP Spin Coefficient, mu";
 ObjDef[grt`NPmu][grtC`root] = grtG`NPmu;
 ObjDef[grt`NPmu][grtC`rootStr] = "mu";
 ObjDef[grt`NPmu][grtC`indexList] = {};
 ObjDef[grt`NPmu][grtC`calcFn] = grtF`calcNPmu;
 ObjDef[grt`NPmu][grtC`calcFnParms] = {};
 ObjDef[grt`NPmu][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPmu][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPmu [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,4,3];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: tau *)
(* ----------------------------- *)
 ObjDef[grt`NPtau][grtC`header] = "NP Spin Coefficient, tau";
 ObjDef[grt`NPtau][grtC`root] = grtG`NPtau;
 ObjDef[grt`NPtau][grtC`rootStr] = "tau";
 ObjDef[grt`NPtau][grtC`indexList] = {};
 ObjDef[grt`NPtau][grtC`calcFn] = grtF`calcNPtau;
 ObjDef[grt`NPtau][grtC`calcFnParms] = {};
 ObjDef[grt`NPtau][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPtau][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPtau [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,3,1,2];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: pi *)
(* ----------------------------- *)
 ObjDef[grt`NPpi][grtC`header] = "NP Spin Coefficient, pi";
 ObjDef[grt`NPpi][grtC`root] = grtG`NPpi;
 ObjDef[grt`NPpi][grtC`rootStr] = "pi";
 ObjDef[grt`NPpi][grtC`indexList] = {};
 ObjDef[grt`NPpi][grtC`calcFn] = grtF`calcNPpi;
 ObjDef[grt`NPpi][grtC`calcFnParms] = {};
 ObjDef[grt`NPpi][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPpi][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPpi [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,4,1];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: epsilon *)
(* ----------------------------- *)
 ObjDef[grt`NPepsilon][grtC`header] = "NP Spin Coefficient, epsilon";
 ObjDef[grt`NPepsilon][grtC`root] = grtG`NPepsilon;
 ObjDef[grt`NPepsilon][grtC`rootStr] = "epsilon";
 ObjDef[grt`NPepsilon][grtC`indexList] = {};
 ObjDef[grt`NPepsilon][grtC`calcFn] = grtF`calcNPepsilon;
 ObjDef[grt`NPepsilon][grtC`calcFnParms] = {};
 ObjDef[grt`NPepsilon][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPepsilon][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPepsilon [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,1] +
               rotbdnbdnbdn[metricName,3,4,1] )/2;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: gamma *)
(* ----------------------------- *)
 ObjDef[grt`NPgamma][grtC`header] = "NP Spin Coefficient, gamma";
 ObjDef[grt`NPgamma][grtC`root] = grtG`NPgamma;
 ObjDef[grt`NPgamma][grtC`rootStr] = "gamma";
 ObjDef[grt`NPgamma][grtC`indexList] = {};
 ObjDef[grt`NPgamma][grtC`calcFn] = grtF`calcNPgamma;
 ObjDef[grt`NPgamma][grtC`calcFnParms] = {};
 ObjDef[grt`NPgamma][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPgamma][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPgamma [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,2] +
               rotbdnbdnbdn[metricName,3,4,2] )/2;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: alpha *)
(* ----------------------------- *)
 ObjDef[grt`NPalpha][grtC`header] = "NP Spin Coefficient, alpha";
 ObjDef[grt`NPalpha][grtC`root] = grtG`NPalpha;
 ObjDef[grt`NPalpha][grtC`rootStr] = "alpha";
 ObjDef[grt`NPalpha][grtC`indexList] = {};
 ObjDef[grt`NPalpha][grtC`calcFn] = grtF`calcNPalpha;
 ObjDef[grt`NPalpha][grtC`calcFnParms] = {};
 ObjDef[grt`NPalpha][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPalpha][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPalpha [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,4] +
               rotbdnbdnbdn[metricName,3,4,4] )/2;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: beta *)
(* ----------------------------- *)
 ObjDef[grt`NPbeta][grtC`header] = "NP Spin Coefficient, beta";
 ObjDef[grt`NPbeta][grtC`root] = grtG`NPbeta;
 ObjDef[grt`NPbeta][grtC`rootStr] = "beta";
 ObjDef[grt`NPbeta][grtC`indexList] = {};
 ObjDef[grt`NPbeta][grtC`calcFn] = grtF`calcNPbeta;
 ObjDef[grt`NPbeta][grtC`calcFnParms] = {};
 ObjDef[grt`NPbeta][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPbeta][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPbeta [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,3] +
               rotbdnbdnbdn[metricName,3,4,3] )/2;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  The following set of obects are complex conjugates *)
(*  of the NP-spin coefficients defined above. They are *)
(*  obtained from the above objects by interchanging *)
(*  3's and 4's in the indices. *)
(* ------------------------------ *)

(* ----------------------------- *)
(*  NP spin coefficient: kappabar *)
(* ----------------------------- *)
 ObjDef[grt`NPkappabar][grtC`header] = "NP Spin Coefficient, kappabar";
 ObjDef[grt`NPkappabar][grtC`root] = grtG`NPkappabar;
 ObjDef[grt`NPkappabar][grtC`rootStr] = "kappabar";
 ObjDef[grt`NPkappabar][grtC`indexList] = {};
 ObjDef[grt`NPkappabar][grtC`calcFn] = grtF`calcNPkappabar;
 ObjDef[grt`NPkappabar][grtC`calcFnParms] = {};
 ObjDef[grt`NPkappabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPkappabar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPkappabar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,4,1,1];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: sigmabar *)
(* ----------------------------- *)
 ObjDef[grt`NPsigmabar][grtC`header] = "NP Spin Coefficient, sigmabar";
 ObjDef[grt`NPsigmabar][grtC`root] = grtG`NPsigmabar;
 ObjDef[grt`NPsigmabar][grtC`rootStr] = "sigmabar";
 ObjDef[grt`NPsigmabar][grtC`indexList] = {};
 ObjDef[grt`NPsigmabar][grtC`calcFn] = grtF`calcNPsigmabar;
 ObjDef[grt`NPsigmabar][grtC`calcFnParms] = {};
 ObjDef[grt`NPsigmabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPsigmabar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPsigmabar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,4,1,4];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: lambdabar *)
(* ----------------------------- *)
 ObjDef[grt`NPlambdabar][grtC`header] = "NP Spin Coefficient, lambdabar";
 ObjDef[grt`NPlambdabar][grtC`root] = grtG`NPlambdabar;
 ObjDef[grt`NPlambdabar][grtC`rootStr] = "lambdabar";
 ObjDef[grt`NPlambdabar][grtC`indexList] = {};
 ObjDef[grt`NPlambdabar][grtC`calcFn] = grtF`calcNPlambdabar;
 ObjDef[grt`NPlambdabar][grtC`calcFnParms] = {};
 ObjDef[grt`NPlambdabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPlambdabar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPlambdabar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,3,3];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: nubar *)
(* ----------------------------- *)
 ObjDef[grt`NPnubar][grtC`header] = "NP Spin Coefficient, nubar";
 ObjDef[grt`NPnubar][grtC`root] = grtG`NPnubar;
 ObjDef[grt`NPnubar][grtC`rootStr] = "nubar";
 ObjDef[grt`NPnubar][grtC`indexList] = {};
 ObjDef[grt`NPnubar][grtC`calcFn] = grtF`calcNPnubar;
 ObjDef[grt`NPnubar][grtC`calcFnParms] = {};
 ObjDef[grt`NPnubar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPnubar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPnubar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,3,2];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: rhobar *)
(* ----------------------------- *)
 ObjDef[grt`NPrhobar][grtC`header] = "NP Spin Coefficient, rhobar";
 ObjDef[grt`NPrhobar][grtC`root] = grtG`NPrhobar;
 ObjDef[grt`NPrhobar][grtC`rootStr] = "rhobar";
 ObjDef[grt`NPrhobar][grtC`indexList] = {};
 ObjDef[grt`NPrhobar][grtC`calcFn] = grtF`calcNPrhobar;
 ObjDef[grt`NPrhobar][grtC`calcFnParms] = {};
 ObjDef[grt`NPrhobar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPrhobar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPrhobar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,4,1,3];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: mubar *)
(* ----------------------------- *)
 ObjDef[grt`NPmubar][grtC`header] = "NP Spin Coefficient, mubar";
 ObjDef[grt`NPmubar][grtC`root] = grtG`NPmubar;
 ObjDef[grt`NPmubar][grtC`rootStr] = "mubar";
 ObjDef[grt`NPmubar][grtC`indexList] = {};
 ObjDef[grt`NPmubar][grtC`calcFn] = grtF`calcNPmubar;
 ObjDef[grt`NPmubar][grtC`calcFnParms] = {};
 ObjDef[grt`NPmubar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPmubar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPmubar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,3,4];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: taubar *)
(* ----------------------------- *)
 ObjDef[grt`NPtaubar][grtC`header] = "NP Spin Coefficient, taubar";
 ObjDef[grt`NPtaubar][grtC`root] = grtG`NPtaubar;
 ObjDef[grt`NPtaubar][grtC`rootStr] = "taubar";
 ObjDef[grt`NPtaubar][grtC`indexList] = {};
 ObjDef[grt`NPtaubar][grtC`calcFn] = grtF`calcNPtaubar;
 ObjDef[grt`NPtaubar][grtC`calcFnParms] = {};
 ObjDef[grt`NPtaubar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPtaubar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPtaubar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,4,1,2];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: pibar *)
(* ----------------------------- *)
 ObjDef[grt`NPpibar][grtC`header] = "NP Spin Coefficient, pibar";
 ObjDef[grt`NPpibar][grtC`root] = grtG`NPpibar;
 ObjDef[grt`NPpibar][grtC`rootStr] = "pibar";
 ObjDef[grt`NPpibar][grtC`indexList] = {};
 ObjDef[grt`NPpibar][grtC`calcFn] = grtF`calcNPpibar;
 ObjDef[grt`NPpibar][grtC`calcFnParms] = {};
 ObjDef[grt`NPpibar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPpibar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPpibar [object_,index_] :=
Module[ { s},
	s = rotbdnbdnbdn[metricName,2,3,1];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: epsilonbar *)
(* ----------------------------- *)
 ObjDef[grt`NPepsilonbar][grtC`header] = "NP Spin Coefficient, epsilonbar";
 ObjDef[grt`NPepsilonbar][grtC`root] = grtG`NPepsilonbar;
 ObjDef[grt`NPepsilonbar][grtC`rootStr] = "epsilonbar";
 ObjDef[grt`NPepsilonbar][grtC`indexList] = {};
 ObjDef[grt`NPepsilonbar][grtC`calcFn] = grtF`calcNPepsilonbar;
 ObjDef[grt`NPepsilonbar][grtC`calcFnParms] = {};
 ObjDef[grt`NPepsilonbar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPepsilonbar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPepsilonbar [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,1] +
               rotbdnbdnbdn[metricName,4,3,1] )/2;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: gammabar *)
(* ----------------------------- *)
 ObjDef[grt`NPgammabar][grtC`header] = "NP Spin Coefficient, gammabar";
 ObjDef[grt`NPgammabar][grtC`root] = grtG`NPgammabar;
 ObjDef[grt`NPgammabar][grtC`rootStr] = "gammabar";
 ObjDef[grt`NPgammabar][grtC`indexList] = {};
 ObjDef[grt`NPgammabar][grtC`calcFn] = grtF`calcNPgammabar;
 ObjDef[grt`NPgammabar][grtC`calcFnParms] = {};
 ObjDef[grt`NPgammabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPgammabar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPgammabar [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,2] +
               rotbdnbdnbdn[metricName,4,3,2] )/2;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: alphabar *)
(* ----------------------------- *)
 ObjDef[grt`NPalphabar][grtC`header] = "NP Spin Coefficient, alphabar";
 ObjDef[grt`NPalphabar][grtC`root] = grtG`NPalphabar;
 ObjDef[grt`NPalphabar][grtC`rootStr] = "alphabar";
 ObjDef[grt`NPalphabar][grtC`indexList] = {};
 ObjDef[grt`NPalphabar][grtC`calcFn] = grtF`calcNPalphabar;
 ObjDef[grt`NPalphabar][grtC`calcFnParms] = {};
 ObjDef[grt`NPalphabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPalphabar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPalphabar [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,3] +
               rotbdnbdnbdn[metricName,4,3,3] )/2;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP spin coefficient: betabar *)
(* ----------------------------- *)
 ObjDef[grt`NPbetabar][grtC`header] = "NP Spin Coefficient, betabar";
 ObjDef[grt`NPbetabar][grtC`root] = grtG`NPbetabar;
 ObjDef[grt`NPbetabar][grtC`rootStr] = "betabar";
 ObjDef[grt`NPbetabar][grtC`indexList] = {};
 ObjDef[grt`NPbetabar][grtC`calcFn] = grtF`calcNPbetabar;
 ObjDef[grt`NPbetabar][grtC`calcFnParms] = {};
 ObjDef[grt`NPbetabar][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`NPbetabar][grtC`depends] = {grt`rot[bdn,bdn,bdn]};

grtF`calcNPbetabar [object_,index_] :=
Module[ { s},
	s = ( rotbdnbdnbdn[metricName,2,1,4] +
               rotbdnbdnbdn[metricName,4,3,4] )/2;
	Return[s];
]; (* end Module *)

End[];

