(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 



Begin["grtG`"];



(* update the main objects list *)







grtF`whenRPhi[] :=

Module[ {},

  If[ grtF`checkIfAssigned[ R[bdn,bdn] ] , (* then *)

    Return[True];

  , (* else *)

    Return[False];

  ]; (* end If *)

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi00 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Phi00][grtC`header] = "Ricci Scalar, Phi00";

 ObjDef[grt`Phi00][grtC`displayName] = grt`Phi00;

 ObjDef[grt`Phi00][grtC`root] = grtG`NPPhi00;

 ObjDef[grt`Phi00][grtC`rootStr] = "Phi00";

 ObjDef[grt`Phi00][grtC`indexList] = {};

 ObjDef[grt`Phi00][grtC`calcFn] = grtF`calcNPPhi00;

 ObjDef[grt`Phi00][grtC`calcFnParms] = {};

 ObjDef[grt`Phi00][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi00][grtC`depends] = { grt`e[bdn,up], grt`NPrho, grt`NPepsilon, 

	grt`NPepsilonbar, grt`NPkappa,

        grt`NPalpha, grt`NPbetabar, grt`NPpi, grt`NPsigma, grt`NPsigmabar, 

        grt`NPkappabar, grt`NPtau };



grtF`calcNPPhi00 [object_, index_] :=

Module[ { a, s},

	s = -NPrho[metricName]*( NPrho[metricName] + NPepsilon[metricName] + NPepsilonbar[metricName] )

           - NPsigma[metricName]*NPsigmabar[metricName] + NPkappabar[metricName]*NPtau[metricName]

           + NPkappa[metricName]*( 3*NPalpha[metricName] + NPbetabar[metricName] - NPpi[metricName] );

	For[ a = 1, a <=  Ndim[metricName] , a++ ,

  	  s = s + ebdnup[metricName,1,a]*D[NPrho[metricName],xup[metricName,a]]

                 - ebdnup[metricName,4,a]*D[NPkappa[metricName],xup[metricName,a]];

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi00 *)

(* ----------------------------- *)

 ObjDef[grt`RPhi00][grtC`displayName] = grt`Phi00;

 ObjDef[grt`RPhi00][grtC`calcFn] = grtF`calcRPhi00;

 ObjDef[grt`RPhi00][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi00][grtC`depends] = { grt`R[bdn,bdn] };



grtF`calcRPhi00 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,1,1];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi01 *)

(* ----------------------------- *)

 ObjDef[grt`Phi01][grtC`header] = "Ricci Scalar, Phi01";

 ObjDef[grt`Phi01][grtC`displayName] = grt`Phi01;

 ObjDef[grt`Phi01][grtC`root] = grtG`NPPhi01;

 ObjDef[grt`Phi01][grtC`rootStr] = "Phi01";

 ObjDef[grt`Phi01][grtC`indexList] = {};

 ObjDef[grt`Phi01][grtC`calcFn] = grtF`calcNPPhi01;

 ObjDef[grt`Phi01][grtC`calcFnParms] = {};

 ObjDef[grt`Phi01][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi01][grtC`depends] = { grt`e[bdn,up], grt`NPalphabar, grt`NPrhobar, 

	grt`NPepsilon, grt`NPepsilonbar, grt`NPbeta,

        grt`NPpibar, grt`NPbetabar, grt`NPsigma, grt`NPkappa, grt`NPlambdabar,

        grt`NPkappabar, grt`NPgammabar };



grtF`calcNPPhi01 [object_, index_] :=

Module[ { a, s},

	s = -NPalphabar[metricName]*( NPrhobar[metricName] + NPepsilon[metricName] - 2*NPepsilonbar[metricName] ) 

           + NPepsilonbar[metricName]*( NPbeta[metricName] - NPpibar[metricName] )

           - NPbetabar[metricName]*NPsigma[metricName] + NPkappabar[metricName]*NPlambdabar[metricName] + NPkappa[metricName]*NPgammabar[metricName] - NPpibar[metricName]*NPrhobar[metricName];

	For[ a = 1, a <=  Ndim[metricName], a++ ,

 	  s = s + ebdnup[metricName,1,a]*D[NPalphabar[metricName],xup[metricName,a]]

                 - ebdnup[metricName,3,a]*D[NPepsilonbar[metricName],xup[metricName,a]];   

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi01 *)

(* ----------------------------- *)

 ObjDef[grt`RPhi01][grtC`displayName] = grt`Phi01;

 ObjDef[grt`RPhi01][grtC`calcFn] = grtF`calcRPhi01;

 ObjDef[grt`RPhi01][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi01][grtC`depends] = { grt`R[bdn,bdn] };



grtF`calcRPhi01 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,1,3];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi02 *)

(* ----------------------------- *)

 ObjDef[grt`Phi02][grtC`header] = "Ricci Scalar, Phi02";

 ObjDef[grt`Phi02][grtC`displayName] = grt`Phi02;

 ObjDef[grt`Phi02][grtC`root] = grtG`NPPhi02;

 ObjDef[grt`Phi02][grtC`rootStr] = "Phi02";

 ObjDef[grt`Phi02][grtC`indexList] = {};

 ObjDef[grt`Phi02][grtC`calcFn] = grtF`calcNPPhi02;

 ObjDef[grt`Phi02][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi02][grtC`depends] = { grt`e[bdn,up], grt`NPlambdabar, grt`NPepsilonbar, 

	grt`NPepsilon, grt`NPrhobar,

 	grt`NPpibar, grt`NPalphabar, grt`NPbeta, grt`NPsigma, 

	grt`NPmubar, grt`NPnubar, grt`NPkappa };

 ObjDef[grt`Phi02][grtC`attributes] = {usediffconstraint};



grtF`calcNPPhi02 [object_, index_] :=

Module[ { a, s},

	s = NPlambdabar[metricName]*( 3*NPepsilonbar[metricName] - NPepsilon[metricName] - NPrhobar[metricName] )

 	   - NPpibar[metricName]*( NPpibar[metricName] + NPalphabar[metricName] - NPbeta[metricName] )

           - NPsigma[metricName]*NPmubar[metricName] + NPnubar[metricName]*NPkappa[metricName];

	For[ a = 1, a <=  Ndim[metricName] , a++ ,

	  s = s + ebdnup[metricName,1,a]*D[NPlambdabar[metricName],xup[metricName,a]]

	         - ebdnup[metricName,3,a]*D[NPpibar[metricName],xup[metricName,a]];

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi02 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`RPhi02][grtC`displayName] = grt`Phi02;

 ObjDef[grt`RPhi02][grtC`calcFn] = grtF`calcRPhi02;

 ObjDef[grt`RPhi02][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi02][grtC`depends] = {grt`R[bdn,bdn]};



grtF`calcRPhi02 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,3,3];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi10 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Phi10][grtC`header] = "Ricci Scalar, Phi10";

 ObjDef[grt`Phi10][grtC`displayName] = grt`Phi10;

 ObjDef[grt`Phi10][grtC`root] = grtG`NPPhi10;

 ObjDef[grt`Phi10][grtC`rootStr] = "Phi10";

 ObjDef[grt`Phi10][grtC`indexList] = {};

 ObjDef[grt`Phi10][grtC`calcFn] = grtF`calcNPPhi10;

 ObjDef[grt`Phi10][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi10][grtC`depends] = { grt`e[bdn,up], grt`NPalpha, grt`NPrho, grt`NPepsilon, 

		grt`NPepsilonbar, grt`NPkappa,

                grt`NPbetabar, grt`NPpi, grt`NPbeta, grt`NPsigmabar, grt`NPlambda,

                grt`NPkappabar, grt`NPgamma };



grtF`calcNPPhi10 [object_, index_] :=

Module[ { a, s},

	s = -NPalpha[metricName]*( NPrho[metricName] + NPepsilonbar[metricName] - 2*NPepsilon[metricName] )

           + NPepsilon[metricName]*( NPbetabar[metricName] - NPpi[metricName] )

           - NPbeta[metricName]*NPsigmabar[metricName] + NPkappa[metricName]*NPlambda[metricName] + NPkappabar[metricName]*NPgamma[metricName] - NPpi[metricName]*NPrho[metricName];

	For[ a = 1, a <=  Ndim[metricName], a++ ,

	  s = s + ebdnup[metricName,1,a]*D[NPalpha[metricName],xup[metricName,a]]

                 - ebdnup[metricName,4,a]*D[NPepsilon[metricName],xup[metricName,a]]; 

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi10 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`RPhi10][grtC`displayName] = grt`Phi10;

 ObjDef[grt`RPhi10][grtC`calcFn] = grtF`calcRPhi10;

 ObjDef[grt`RPhi10][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi10][grtC`depends] = { grt`R[bdn,bdn] };



grtF`calcRPhi10 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,1,4];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi11 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Phi11][grtC`header] = "Ricci Scalar, Phi11";  

 ObjDef[grt`Phi11][grtC`displayName] = grt`Phi11;

 ObjDef[grt`Phi11][grtC`root] = grtG`NPPhi11;  

 ObjDef[grt`Phi11][grtC`rootStr] = "Phi11";  

 ObjDef[grt`Phi11][grtC`indexList] = {};

 ObjDef[grt`Phi11][grtC`calcFn] = grtF`calcNPPhi11;  

 ObjDef[grt`Phi11][grtC`calcFnParms] = {};

 ObjDef[grt`Phi11][grtC`symmetry] = grtF`symscalar;  

 ObjDef[grt`Phi11][grtC`depends] = { grt`e[bdn,up], grt`NPbeta, grt`NPgamma, 

	grt`NPtau, grt`NPpi, grt`NPgamma, grt`NPmu, grt`NPrho,

        grt`NPpibar, grt`NPtau, grt`NPalphabar, grt`NPalpha, 

	grt`NPgammabar, grt`NPmubar,

        grt`NPepsilon, grt`NPrhobar, grt`NPbeta, grt`NPtaubar, grt`NPepsilonbar,

        grt`NPbetabar, grt`NPlambda, grt`NPsigma, grt`NPnu, grt`NPkappa };

 ObjDef[grt`Phi11][grtC`attributes] = {usediffconstraint};



grtF`calcNPPhi11 [object_, index_] := 

Module[ { a, s},

	s = -NPpi[metricName]*( NPbeta[metricName] + NPtau[metricName] )

	   - NPrho[metricName]*( NPgamma[metricName] + NPmu[metricName] ) + NPalpha[metricName]*( -NPpibar[metricName] - NPtau[metricName] - NPalphabar[metricName] + 2*NPbeta[metricName] ) 

	   + NPepsilon[metricName]*( NPgammabar[metricName] + NPmubar[metricName] + 2*NPgamma[metricName] - NPmu[metricName] ) 

	   + NPgamma[metricName]*NPrhobar[metricName] - NPbeta[metricName]*NPtaubar[metricName] + NPgamma[metricName]*NPepsilonbar[metricName] - NPbeta[metricName]*NPbetabar[metricName] + NPlambda[metricName]*NPsigma[metricName] + NPnu[metricName]*NPkappa[metricName];  

	For[ a = 1, a <=  Ndim[metricName], a++ ,

	  s = s + ebdnup[metricName,1,a]*D[NPgamma[metricName],xup[metricName,a]]

		 - ebdnup[metricName,2,a]*D[NPepsilon[metricName],xup[metricName,a]] 

		 + ebdnup[metricName,3,a]*D[NPalpha[metricName],xup[metricName,a]] 

		 - ebdnup[metricName,4,a]*D[NPbeta[metricName],xup[metricName,a]];

	]; (* end For *)  

	s = s/2;  

	Return[s];  

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi11 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`RPhi11][grtC`displayName] = grt`Phi11;

 ObjDef[grt`RPhi11][grtC`calcFn] = grtF`calcRPhi11;

 ObjDef[grt`RPhi11][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi11][grtC`depends] = { grt`R[bdn,bdn] };





grtF`calcRPhi11 [object_, index_] :=

Module[ { s},

	s = (1/4)*(Rbdnbdn[metricName,1,2]+Rbdnbdn[metricName,3,4]);

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi12 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Phi12][grtC`header] = "Ricci Scalar, Phi12";

 ObjDef[grt`Phi12][grtC`displayName] = grt`Phi12;

 ObjDef[grt`Phi12][grtC`root] = grtG`NPPhi12;

 ObjDef[grt`Phi12][grtC`rootStr] = "Phi12";

 ObjDef[grt`Phi12][grtC`indexList] = {};

 ObjDef[grt`Phi12][grtC`calcFn] = grtF`calcNPPhi12;

 ObjDef[grt`Phi12][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi12][grtC`depends] = { grt`e[bdn,up], grt`NPgamma, grt`NPtau, grt`NPalphabar, 

	grt`NPbeta, grt`NPgammabar, grt`NPmu,

        grt`NPalpha, grt`NPlambdabar, grt`NPsigma, grt`NPnu, grt`NPepsilon, grt`NPnubar };



grtF`calcNPPhi12 [object_, index_] :=

Module[ { a, s},

	s = -NPgamma[metricName]*( NPtau[metricName] - NPalphabar[metricName] - NPbeta[metricName] ) 

           + NPbeta[metricName]*( NPgamma[metricName] - NPgammabar[metricName] - NPmu[metricName] )

           - NPmu[metricName]*NPtau[metricName] - NPalpha[metricName]*NPlambdabar[metricName] + NPsigma[metricName]*NPnu[metricName] + NPepsilon[metricName]*NPnubar[metricName];

	For[ a = 1, a <=  Ndim[metricName], a++ ,

	  s = s + ebdnup[metricName,3,a]*D[NPgamma[metricName],xup[metricName,a]]

		 - ebdnup[metricName,2,a]*D[NPbeta[metricName],xup[metricName,a]]

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi12 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`RPhi12][grtC`displayName] = grt`Phi12;

 ObjDef[grt`RPhi12][grtC`calcFn] = grtF`calcRPhi12;

 ObjDef[grt`RPhi12][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi12][grtC`depends] = {grt`R[bdn,bdn]};



grtF`calcRPhi12 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,2,3];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi20 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Phi20][grtC`header] = "Ricci Scalar, Phi20";

 ObjDef[grt`Phi20][grtC`displayName] = grt`Phi20;

 ObjDef[grt`Phi20][grtC`root] = grtG`NPPhi20;

 ObjDef[grt`Phi20][grtC`rootStr] = "Phi20";

 ObjDef[grt`Phi20][grtC`indexList] = {};

 ObjDef[grt`Phi20][grtC`calcFn] = grtF`calcNPPhi20;

 ObjDef[grt`Phi20][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi20][grtC`depends] = { grt`e[bdn,up], grt`NPlambda, grt`NPepsilon, 

	grt`NPepsilonbar, grt`NPrho,

        grt`NPpi, grt`NPalpha, grt`NPbetabar, grt`NPsigmabar, 

	grt`NPmu, grt`NPnu, grt`NPkappabar };



grtF`calcNPPhi20 [object_, index_] :=

Module[ { a, s},

	s = NPlambda[metricName]*( 3*NPepsilon[metricName] - NPepsilonbar[metricName] - NPrho[metricName] )

 	   - NPpi[metricName]*( NPpi[metricName] + NPalpha[metricName] - NPbetabar[metricName] )

           - NPsigmabar[metricName]*NPmu[metricName] + NPnu[metricName]*NPkappabar[metricName];

	For[ a = 1, a <=  Ndim[metricName], a++ ,

	  s = s + ebdnup[metricName,1,a]*D[NPlambda[metricName],xup[metricName,a]]

	         - ebdnup[metricName,4,a]*D[NPpi[metricName],xup[metricName,a]];

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi20 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`RPhi20][grtC`displayName] = grt`Phi20;

 ObjDef[grt`RPhi20][grtC`calcFn] = grtF`calcRPhi20;

 ObjDef[grt`RPhi20][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi20][grtC`depends] = {grt`R[bdn,bdn]};



grtF`calcRPhi20 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,4,4];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NPPhi21 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Phi21][grtC`header] = "Ricci Scalar, Phi21";

 ObjDef[grt`Phi21][grtC`displayName] = grt`Phi21;

 ObjDef[grt`Phi21][grtC`root] = grtG`NPPhi21;

 ObjDef[grt`Phi21][grtC`rootStr] = "Phi21";

 ObjDef[grt`Phi21][grtC`indexList] = {};

 ObjDef[grt`Phi21][grtC`calcFn] = grtF`calcNPPhi21;

 ObjDef[grt`Phi21][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi21][grtC`depends] = { grt`e[bdn,up], grt`NPgammabar, grt`NPtaubar, 

	grt`NPalpha, grt`NPbetabar, grt`NPgamma, grt`NPmubar,

        grt`NPalphabar, grt`NPlambda, grt`NPsigmabar, grt`NPnubar, 

	grt`NPepsilonbar, grt`NPnu };



grtF`calcNPPhi21 [object_, index_] :=

Module[ { a, s},

	s = -NPgammabar[metricName]*( NPtaubar[metricName] - NPalpha[metricName] - NPbetabar[metricName] )

           + NPbetabar[metricName]*( NPgammabar[metricName] - NPgamma[metricName] - NPmubar[metricName] )

           - NPmubar[metricName]*NPtaubar[metricName] - NPalphabar[metricName]*NPlambda[metricName] + NPsigmabar[metricName]*NPnubar[metricName] + NPepsilonbar[metricName]*NPnu[metricName];

	For[ a = 1, a <=  Ndim[metricName], a++ ,

	  s = s + ebdnup[metricName,4,a]*D[NPgammabar[metricName],xup[metricName,a]]

		 - ebdnup[metricName,2,a]*D[NPbetabar[metricName],xup[metricName,a]]

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi21 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`RPhi21][grtC`displayName] = grt`Phi21;

 ObjDef[grt`RPhi21][grtC`calcFn] = grtF`calcRPhi21;

 ObjDef[grt`RPhi21][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi21][grtC`depends] = {grt`R[bdn,bdn]};



grtF`calcRPhi21 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,2,4];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Phi22 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Phi22][grtC`header] = "Ricci Scalar, Phi22";

 ObjDef[grt`Phi22][grtC`displayName] = grt`Phi22;

 ObjDef[grt`Phi22][grtC`root] = grtG`NPPhi22;

 ObjDef[grt`Phi22][grtC`rootStr] = "Phi22";

 ObjDef[grt`Phi22][grtC`indexList] = {};

 ObjDef[grt`Phi22][grtC`calcFn] = grtF`calcNPPhi22;

 ObjDef[grt`Phi22][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Phi22][grtC`depends] = { grt`e[bdn,up], grt`NPnu, grt`NPtau, 

	grt`NPbeta, grt`NPalphabar, grt`NPmu, grt`NPgamma,

        grt`NPgammabar, grt`NPlambda, grt`NPlambdabar, grt`NPnubar, grt`NPpi };



grtF`calcNPPhi22 [object_, index_] :=

Module[ { a, s},

	s = -NPnu[metricName]*( NPtau[metricName] - 3*NPbeta[metricName] - NPalphabar[metricName] )

           - NPmu[metricName]*( NPmu[metricName] + NPgamma[metricName] + NPgammabar[metricName] )

           - NPlambda[metricName]*NPlambdabar[metricName] + NPnubar[metricName]*NPpi[metricName];

	For[ a = 1, a <=  Ndim[metricName], a++ ,

	  s = s + ebdnup[metricName,3,a]*D[NPnu[metricName],xup[metricName,a]]

	         - ebdnup[metricName,2,a]*D[NPmu[metricName],xup[metricName,a]]

	]; (* end For *)

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Phi22 *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`RPhi22][grtC`displayName] = grt`Phi22;

 ObjDef[grt`RPhi22][grtC`calcFn] = grtF`calcRPhi22;

 ObjDef[grt`RPhi22][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RPhi22][grtC`depends] = {grt`R[bdn,bdn]};



grtF`calcRPhi22 [object_, index_] :=

Module[ { s},

	s = (1/2)*Rbdnbdn[metricName,2,2];

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  NP Lambda *)

(* ----------------------------- *)

(* (  ) *)

 ObjDef[grt`Lambda][grtC`header] = "Lambda = Ricci Scalar/24";

 ObjDef[grt`Lambda][grtC`displayName] = grt`Lambda;

 ObjDef[grt`Lambda][grtC`root] = grtG`NPLambda;

 ObjDef[grt`Lambda][grtC`rootStr] = "Lambda";

 ObjDef[grt`Lambda][grtC`indexList] = {};

 ObjDef[grt`Lambda][grtC`calcFn] = grtF`calcNPLambda;

 ObjDef[grt`Lambda][grtC`symmetry] = grtF`symscalar;

 ObjDef[grt`Lambda][grtC`depends] = { grt`e[bdn,up], grt`NPepsilonbar, 

	grt`NPrho, grt`NPrhobar, grt`NPepsilon, grt`NPgamma,

        grt`NPbeta, grt`NPtau, grt`NPbetabar, grt`NPpi, grt`NPalpha, grt`NPtaubar,

        grt`NPalphabar, grt`NPnu, grt`NPkappa, 

	grt`NPmubar, grt`NPlambda, grt`NPsigma,

        grt`NPpibar, grt`NPmu, grt`NPgammabar };



grtF`calcNPLambda [object_, index_] :=

Module[ { a, s},

	s = NPtau[metricName]*NPpi[metricName] + 

	    NPnu[metricName]*NPkappa[metricName] - 

	    NPalpha[metricName]*NPalphabar[metricName] - 

	    NPbeta[metricName]*NPbetabar[metricName] - 

	    NPmu[metricName]*NPrho[metricName] - 

	    NPlambda[metricName]*NPsigma[metricName] + 

	    2*NPalpha[metricName]*NPbeta[metricName] 

             - NPepsilon[metricName]*NPgammabar[metricName] + 

	     NPbeta[metricName]*NPtaubar[metricName] + 

	     NPbeta[metricName]*NPpi[metricName] - 

	     NPalpha[metricName]*NPtau[metricName] + 

	     NPalpha[metricName]*NPpibar[metricName] - 

	     2*NPgamma[metricName]*NPepsilon[metricName] - 

	     NPgamma[metricName]*NPepsilonbar[metricName]

             - NPepsilon[metricName]*NPmu[metricName] + 

	     NPepsilon[metricName]*NPmubar[metricName] + 

	     NPgamma[metricName]*NPrho[metricName] + 

	     NPgamma[metricName]*NPrhobar[metricName] + 

	     2*NPtau[metricName]*NPbetabar[metricName] - 

	     2*NPtau[metricName]*NPtaubar[metricName]

             - 2*NPrho[metricName]*NPmubar[metricName] + 

	     2*NPrho[metricName]*NPgammabar[metricName];



	For[ a = 1, a <=  Ndim[metricName], a++ ,

	  s = s - ebdnup[metricName,1,a]*

		  D[NPgamma[metricName],xup[metricName,a]]

		- ebdnup[metricName,2,a]*

	   D[(2*NPrho[metricName]-NPepsilon[metricName]),xup[metricName,a]]

		 + ebdnup[metricName,3,a]*

		   D[NPalpha[metricName],xup[metricName,a]]

	         + ebdnup[metricName,4,a]*

	   D[(2*NPtau[metricName]-NPbeta[metricName]),xup[metricName,a]]; 

	]; (* end For *)

	s = s/6;

	Return[s];

]; (* end Module *)



(* ----------------------------- *)

(*  Ricci Lambda *)

(* ----------------------------- *)

 ObjDef[grt`RLambda][grtC`displayName] = grt`Lambda;

 ObjDef[grt`RLambda][grtC`calcFn] = grtF`calcRLambda;

 ObjDef[grt`RLambda][grtC`useWhen] = grtF`whenRPhi;

 ObjDef[grt`RLambda][grtC`depends] = {grt`R[bdn,bdn]};



grtF`calcRLambda [object_, index_] :=

Module[ { s},

	s = (1/12)*(Rbdnbdn[metricName,1,2]-Rbdnbdn[metricName,3,4]);

	Return[-s];

]; (* end Module *)



End[];



