(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*)  

Begin["grtG`"];


grtF`whenWPsi[ ] :=
Module[ {},
  If[ grtF`checkIfAssigned[ R[bdn,bdn] ] , (* then *)
    Return[True];
  , (* else *)
    Return[False];
  ]; (* end If *)
]; (* end Module *)

(* ----------------------------- *)
(*  Psi0 *)
(* ----------------------------- *)
 ObjDef[grt`Psi0][grtC`header] = "Weyl Scalar, NP Psi0";
 ObjDef[grt`Psi0][grtC`root] = grtG`Psi0;
 ObjDef[grt`Psi0][grtC`rootStr] = "Psi0";
 ObjDef[grt`Psi0][grtC`indexList] = {};
 ObjDef[grt`Psi0][grtC`calcFn] = grtF`calcPsi0;
 ObjDef[grt`Psi0][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Psi0][grtC`depends] = { grt`e[bdn,up], grt`NPsigma, grt`NPrho, 
	grt`NPrhobar, grt`NPepsilon, grt`NPepsilonbar,
        grt`NPkappa, grt`NPtau, grt`NPpibar, grt`NPalphabar, grt`NPbeta };

grtF`calcPsi0 [object_, index_] :=
Module[ { a, s},
	s = -NPsigma[metricName]*( NPrho[metricName] + NPrhobar[metricName] + 3*NPepsilon[metricName] - NPepsilonbar[metricName] ) 
           + NPkappa[metricName]*( NPtau[metricName] - NPpibar[metricName] + NPalphabar[metricName] + 3*NPbeta[metricName] );
        For[ a = 1, a <=  Ndim[metricName], a++ ,
          s = s + ebdnup[metricName,1,a]*D[NPsigma[metricName],xup[metricName,a]]
                 - ebdnup[metricName,3,a]*D[NPkappa[metricName],xup[metricName,a]];
        ]; (* end For *)   
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  Psi0 *)
(* ----------------------------- *)
(* (  ) *)
 ObjDef[grt`WPsi0][grtC`displayName] = Psi0;
 ObjDef[grt`WPsi0][grtC`calcFn] = grtF`calcWPsi0;
 ObjDef[grt`WPsi0][grtC`useWhen] = grtF`whenWPsi;
 ObjDef[grt`WPsi0][grtC`depends] = {grt`Weyl[bdn,bdn,bdn,bdn]};

grtF`calcWPsi0 [object_, index_] :=
Module[ { s},
	s = Cbdnbdnbdnbdn[metricName,1,3,1,3];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP Psi1 *)
(* ----------------------------- *)
(* (  ) *)
 ObjDef[grt`Psi1][grtC`header] = "Weyl Scalar, NP Psi1";
 ObjDef[grt`Psi1][grtC`root] = grtG`Psi1;
 ObjDef[grt`Psi1][grtC`rootStr] = "Psi1";
 ObjDef[grt`Psi1][grtC`indexList] = {};
 ObjDef[grt`Psi1][grtC`calcFn] = grtF`calcPsi1;
 ObjDef[grt`Psi1][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Psi1][grtC`depends] = { grt`e[bdn,up], grt`NPbeta, grt`NPrhobar, 
		grt`NPepsilonbar, grt`NPepsilon, grt`NPalphabar,
                grt`NPpibar, grt`NPsigma, grt`NPalpha, grt`NPpi, 
		grt`NPkappa, grt`NPmu, grt`NPgamma };

grtF`calcPsi1 [object_, index_] :=
Module[ { a, s},
	s = -NPbeta[metricName]*( NPrhobar[metricName] - NPepsilonbar[metricName] ) 
           + NPepsilon[metricName]*( NPalphabar[metricName] - NPpibar[metricName] ) 
           - NPsigma[metricName]*( NPalpha[metricName] + NPpi[metricName] )
           + NPkappa[metricName]*( NPmu[metricName] + NPgamma[metricName] );
        For[ a = 1, a <=  Ndim[metricName], a++ ,
          s = s + ebdnup[metricName,1,a]*D[NPbeta[metricName],xup[metricName,a]] 
	         - ebdnup[metricName,3,a]*D[NPepsilon[metricName],xup[metricName,a]];
	]; (* end For *)
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  Psi1 *)
(* ----------------------------- *)
(* (  ) *)
 ObjDef[grt`WPsi1][grtC`displayName] = Psi1;
 ObjDef[grt`WPsi1][grtC`calcFn] = grtF`calcWPsi1;
 ObjDef[grt`WPsi1][grtC`useWhen] = grtF`whenWPsi;
 ObjDef[grt`WPsi1][grtC`depends] = {grt`Weyl[bdn,bdn,bdn,bdn]};

grtF`calcWPsi1 [object_, index_] :=
Module[ { s},
	s = Cbdnbdnbdnbdn[metricName,1,2,1,3];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP Psi2 *)
(* ----------------------------- *)
(* (  ) *)
 ObjDef[grt`Psi2][grtC`header] = "Weyl Scalar, NP Psi2";
 ObjDef[grt`Psi2][grtC`root] = grtG`Psi2;
 ObjDef[grt`Psi2][grtC`rootStr] = "Psi2";
 ObjDef[grt`Psi2][grtC`indexList] = {};
 ObjDef[grt`Psi2][grtC`calcFn] = grtF`calcPsi2;
 ObjDef[grt`Psi2][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Psi2][grtC`depends] = { grt`e[bdn,up], grt`NPepsilonbar, 
	grt`NPrho, grt`NPrhobar, grt`NPepsilon, grt`NPgamma,
        grt`NPalpha, grt`NPtaubar, grt`NPpi, grt`NPbetabar, grt`NPtau,
        grt`NPgammabar, grt`NPmu, grt`NPmubar, grt`NPbeta, grt`NPpibar, grt`NPalphabar,
        grt`NPnu, grt`NPkappa, grt`NPlambda, grt`NPsigma };

grtF`calcPsi2 [object_, index_] :=
Module[ { a, s},
	s = ( NPepsilonbar[metricName] + 2*NPrho[metricName] - NPrhobar[metricName] + 2*NPepsilon[metricName] )*NPgamma[metricName]
           + ( -2*NPalpha[metricName] - NPtaubar[metricName] - NPpi[metricName] + NPbetabar[metricName])*NPtau[metricName] 
           + ( NPgammabar[metricName] + NPmu[metricName] - NPmubar[metricName] )*( NPrho[metricName] + NPepsilon[metricName] )
           + ( -2*NPbeta[metricName] - NPpibar[metricName] + NPalphabar[metricName] )*NPalpha[metricName]
           + ( -NPtaubar[metricName] - NPpi[metricName] + NPbetabar[metricName]) *NPbeta[metricName]
           + 2*( NPnu[metricName]*NPkappa[metricName] -NPlambda[metricName]*NPsigma[metricName] );
     	For[ a = 1, a <=  Ndim[metricName], a++ ,
 	  s = s + ebdnup[metricName,1,a]*D[NPgamma[metricName],xup[metricName,a]]
                 - ebdnup[metricName,2,a]*D[(NPrho[metricName]+NPepsilon[metricName]),xup[metricName,a]]
                 + ebdnup[metricName,4,a]*D[(NPbeta[metricName]+NPtau[metricName]),xup[metricName,a]] 
                 - ebdnup[metricName,3,a]*D[NPalpha[metricName],xup[metricName,a]];
	]; (* end For *)
	s = s/3;
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  Psi2 *)
(* ----------------------------- *)
 ObjDef[grt`WPsi2][grtC`displayName] = Psi2;
 ObjDef[grt`WPsi2][grtC`calcFn] = grtF`calcWPsi2;
 ObjDef[grt`WPsi2][grtC`useWhen] = grtF`whenWPsi;
 ObjDef[grt`WPsi2][grtC`depends] = {grt`Weyl[bdn,bdn,bdn,bdn]};

grtF`calcWPsi2 [object_, index_] :=
Module[ { s},
	s = Cbdnbdnbdnbdn[metricName,1,3,4,2];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP Psi3 *)
(* ----------------------------- *)
 ObjDef[grt`Psi3][grtC`header] = "Weyl Scalar, NP Psi3";
 ObjDef[grt`Psi3][grtC`root] = grtG`Psi3;
 ObjDef[grt`Psi3][grtC`rootStr] = "Psi3";
 ObjDef[grt`Psi3][grtC`indexList] = {};
 ObjDef[grt`Psi3][grtC`calcFn] = grtF`calcPsi3;
 ObjDef[grt`Psi3][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Psi3][grtC`depends] = { grt`e[bdn,up], grt`NPalpha, 
		grt`NPgammabar, grt`NPmubar, grt`NPgamma, grt`NPbetabar,
                grt`NPtaubar, grt`NPnu, grt`NPrho, grt`NPepsilon, 
		grt`NPlambda, grt`NPtau, grt`NPbeta};

grtF`calcPsi3 [object_, index_] :=
Module[ { a, s},
	s = NPalpha[metricName]*( NPgammabar[metricName] - NPmubar[metricName] ) 
           + NPgamma[metricName]*( NPbetabar[metricName] - NPtaubar[metricName] )
           + NPnu[metricName]*( NPrho[metricName] + NPepsilon[metricName] )
           - NPlambda[metricName]*( NPtau[metricName] + NPbeta[metricName] );
        For[ a = 1, a <=  Ndim[metricName], a++ ,
          s = s - ebdnup[metricName,2,a]*D[NPalpha[metricName],xup[metricName,a]]
 	         + ebdnup[metricName,4,a]*D[NPgamma[metricName],xup[metricName,a]];
	]; (* end For *)
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  Psi3 *)
(* ----------------------------- *)
 ObjDef[grt`WPsi3][grtC`displayName] = Psi3;
 ObjDef[grt`WPsi3][grtC`calcFn] = grtF`calcWPsi3;
 ObjDef[grt`WPsi3][grtC`useWhen] = grtF`whenWPsi;
 ObjDef[grt`WPsi3][grtC`depends] = {grt`Weyl[bdn,bdn,bdn,bdn]};

grtF`calcWPsi3 [object_, index_] :=
Module[ { s},
	s = Cbdnbdnbdnbdn[metricName,1,2,4,2];
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  NP Psi4 *)
(* ----------------------------- *)
 ObjDef[grt`Psi4][grtC`header] = "Weyl Scalar, NP Psi4";
 ObjDef[grt`Psi4][grtC`root] = grtG`Psi4;
 ObjDef[grt`Psi4][grtC`rootStr] = "Psi4";
 ObjDef[grt`Psi4][grtC`indexList] = {};
 ObjDef[grt`Psi4][grtC`calcFn] = grtF`calcPsi4;
 ObjDef[grt`Psi4][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`Psi4][grtC`depends] = { grt`e[bdn,up], grt`NPlambda, grt`NPmu, 
	grt`NPmubar, grt`NPgamma, grt`NPgammabar,
        grt`NPpi, grt`NPtaubar, grt`NPalpha, grt`NPbetabar };

grtF`calcPsi4 [object_, index_] :=
Module[ { a, s},
	s = -NPlambda[metricName]*( NPmu[metricName] + NPmubar[metricName] + 3*NPgamma[metricName] - NPgammabar[metricName] ) 
           + NPnu[metricName]*( NPpi[metricName] - NPtaubar[metricName] + 3*NPalpha[metricName] + NPbetabar[metricName]);
	For[ a = 1, a <=  Ndim[metricName], a++ ,
   	  s = s - ebdnup[metricName,2,a]*D[NPlambda[metricName],xup[metricName,a]]
                 + ebdnup[metricName,4,a]*D[NPnu[metricName],xup[metricName,a]];
	]; (* end For *)
	Return[s];
]; (* end Module *)

(* ----------------------------- *)
(*  Psi4 *)
(* ----------------------------- *)
 ObjDef[grt`WPsi4][grtC`displayName] = Psi4;
 ObjDef[grt`WPsi4][grtC`calcFn] = grtF`calcWPsi4;
 ObjDef[grt`WPsi4][grtC`useWhen] = grtF`whenWPsi;
 ObjDef[grt`WPsi4][grtC`depends] = {grt`Weyl[bdn,bdn,bdn,bdn]};

grtF`calcWPsi4 [object_, index_] :=
Module[ { s},
	s = Cbdnbdnbdnbdn[metricName,2,4,2,4];
	Return[s];
]; (* end Module *)

End[];

