(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 

Begin["grtG`"];


(* =================================================================== *)
(*  Object definitions. *)
(* =================================================================== *)

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, l(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPl(up)][grtC`header] = "Null tetrad (contravaraint components)";
 ObjDef[NPl(up)][grtC`root] = NPlup;
 ObjDef[NPl(up)][grtC`rootStr] = "l";
 ObjDef[NPl(up)][grtC`indexList] = {up};
 ObjDef[NPl(up)][grtC`calcFn] = grtF`calce1up;
 ObjDef[NPl(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPl(up)][grtC`depends] = { grt`e[bdn,up] };

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, n(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPn(up)][grtC`header] = "Null tetrad (contravaraint components)";
 ObjDef[NPn(up)][grtC`root] = NPnup;
 ObjDef[NPn(up)][grtC`rootStr] = "n";
 ObjDef[NPn(up)][grtC`indexList] = {up};
 ObjDef[NPn(up)][grtC`calcFn] = grtF`calce2up;
 ObjDef[NPn(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPn(up)][grtC`depends] = { grt`e[bdn,up] };

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, m(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPm(up)][grtC`header] = "Null tetrad (contravaraint components)";
 ObjDef[NPm(up)][grtC`root] = NPmup;
 ObjDef[NPm(up)][grtC`rootStr] = "m";
 ObjDef[NPm(up)][grtC`indexList] = {up};
 ObjDef[NPm(up)][grtC`calcFn] = grtF`calce3up;
 ObjDef[NPm(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPm(up)][grtC`depends] = { grt`e[bdn,up] };

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, mbar(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPmbar(up)][grtC`header] = "Null tetrad (contravaraint components)";
 ObjDef[NPmbar(up)][grtC`root] = NPmbarup;
 ObjDef[NPmbar(up)][grtC`rootStr] = "mbar";
 ObjDef[NPmbar(up)][grtC`indexList] = {up};
 ObjDef[NPmbar(up)][grtC`calcFn] = grtF`calce4up;
 ObjDef[NPmbar(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPmbar(up)][grtC`depends] = { grt`e[bdn,up] };

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, l(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPl(dn)][grtC`header] = "Null tetrad (covaraint components)";
 ObjDef[NPl(dn)][grtC`root] = NPldn;
 ObjDef[NPl(dn)][grtC`rootStr] = "l";
 ObjDef[NPl(dn)][grtC`indexList] = {dn};
 ObjDef[NPl(dn)][grtC`calcFn] = grtF`calce1dn;
 ObjDef[NPl(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPl(dn)][grtC`depends] = { grt`e[bdn,dn] };

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, n(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPn(dn)][grtC`header] = "Null tetrad (covaraint components)";
 ObjDef[NPn(dn)][grtC`root] = NPndn;
 ObjDef[NPn(dn)][grtC`rootStr] = "n";
 ObjDef[NPn(dn)][grtC`indexList] = {dn};
 ObjDef[NPn(dn)][grtC`calcFn] = grtF`calce2dn;
 ObjDef[NPn(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPn(dn)][grtC`depends] = { grt`e[bdn,dn] };

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, m(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPm(dn)][grtC`header] = "Null tetrad (covaraint components)";
 ObjDef[NPm(dn)][grtC`root] = NPmdn;
 ObjDef[NPm(dn)][grtC`rootStr] = "m";
 ObjDef[NPm(dn)][grtC`indexList] = {dn};
 ObjDef[NPm(dn)][grtC`calcFn] = grtF`calce3dn;
 ObjDef[NPm(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPm(dn)][grtC`depends] = { grt`e[bdn,dn] };

(* ------------------------------------------------------------------- *)
(*  NP tetrad vector, mbar(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[NPmbar(dn)][grtC`header] = "Null tetrad (covaraint components)";
 ObjDef[NPmbar(dn)][grtC`root] = NPmbardn;
 ObjDef[NPmbar(dn)][grtC`rootStr] = "mbar";
 ObjDef[NPmbar(dn)][grtC`indexList] = {dn};
 ObjDef[NPmbar(dn)][grtC`calcFn] = grtF`calce4dn;
 ObjDef[NPmbar(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[NPmbar(dn)][grtC`depends] = { grt`e[bdn,dn] };




(* ------------------------------------------------------------------- *)
(*  Basis vector, e1(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[w1(dn)][grtC`header] = "Basis (covariant components)";
 ObjDef[w1(dn)][grtC`root] = e1dn;
 ObjDef[w1(dn)][grtC`rootStr] = "omega1";
 ObjDef[w1(dn)][grtC`indexList] = {dn};
 ObjDef[w1(dn)][grtC`calcFn] = grtF`calce1dn;
 ObjDef[w1(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[w1(dn)][grtC`depends] = { grt`e[bdn,dn] };

grtF`calce1dn [object_, list_] :=
Module[ {	s},
  s = ebdndn[metricName,1,a1];
  Return[s];
]; (* end Module *)

(* ------------------------------------------------------------------- *)
(*  Basis vector, e2(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[w2(dn)][grtC`header] = "Basis (covariant components)";
 ObjDef[w2(dn)][grtC`root] = e2dn;
 ObjDef[w2(dn)][grtC`rootStr] = "omega2";
 ObjDef[w2(dn)][grtC`indexList] = {dn};
 ObjDef[w2(dn)][grtC`calcFn] = grtF`calce2dn;
 ObjDef[w2(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[w2(dn)][grtC`depends] = { grt`e[bdn,dn] };

grtF`calce2dn [object_, list_] :=
Module[ {	s},
  s = ebdndn[metricName,2,a1];
  Return[s];
]; (* end Module *)

(* ------------------------------------------------------------------- *)
(*  Basis vector, e3(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[w3(dn)][grtC`header] = "Basis (covariant components)";
 ObjDef[w3(dn)][grtC`root] = e3dn;
 ObjDef[w3(dn)][grtC`rootStr] = "omega3";
 ObjDef[w3(dn)][grtC`indexList] = {dn};
 ObjDef[w3(dn)][grtC`calcFn] = grtF`calce3dn;
 ObjDef[w3(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[w3(dn)][grtC`depends] = { grt`e[bdn,dn] };

grtF`calce3dn [object_, list_] :=
Module[ {	s},
  s = ebdndn[metricName,3,a1];
  Return[s];
]; (* end Module *)

(* ------------------------------------------------------------------- *)
(*  Basis vector, e4(dn) *)
(* ------------------------------------------------------------------- *)
 ObjDef[w4(dn)][grtC`header] = "Basis (covariant components)";
 ObjDef[w4(dn)][grtC`root] = e4dn;
 ObjDef[w4(dn)][grtC`rootStr] = "omega4";
 ObjDef[w4(dn)][grtC`indexList] = {dn};
 ObjDef[w4(dn)][grtC`calcFn] = grtF`calce4dn;
 ObjDef[w4(dn)][grtC`symmetry] = grtF`symvector;
 ObjDef[w4(dn)][grtC`depends] = { grt`e[bdn,dn] };

grtF`calce4dn [object_, list_] :=
Module[ {	s},
  s = ebdndn[metricName,4,a1];
  Return[s];
]; (* end Module *)


(* ------------------------------------------------------------------- *)
(*  Basis vector, e1(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[e1(up)][grtC`header] = "Basis (contravariant components)";
 ObjDef[e1(up)][grtC`root] = e1up;
 ObjDef[e1(up)][grtC`rootStr] = "e1";
 ObjDef[e1(up)][grtC`indexList] = {up};
 ObjDef[e1(up)][grtC`calcFn] = grtF`calce1up;
 ObjDef[e1(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[e1(up)][grtC`depends] = { grt`e[bdn,up] };

grtF`calce1up [object_, list_] :=
Module[ {	s},
  s = ebdnup[metricName,1,a1];
  Return[s];
]; (* end Module *)

(* ------------------------------------------------------------------- *)
(*  Basis vector, e2(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[e2(up)][grtC`header] = "Basis (contravariant components)";
 ObjDef[e2(up)][grtC`root] = e2up;
 ObjDef[e2(up)][grtC`rootStr] = "e2";
 ObjDef[e2(up)][grtC`indexList] = {up};
 ObjDef[e2(up)][grtC`calcFn] = grtF`calce2up;
 ObjDef[e2(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[e2(up)][grtC`depends] = { grt`e[bdn,up] };

grtF`calce2up [object_, list_] :=
Module[ {	s},
  s = ebdnup[metricName,2,a1];
  Return[s];
]; (* end Module *)

(* ------------------------------------------------------------------- *)
(*  Basis vector, e3(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[e3(up)][grtC`header] = "Basis (contravariant components)";
 ObjDef[e3(up)][grtC`root] = e3up;
 ObjDef[e3(up)][grtC`rootStr] = "e3";
 ObjDef[e3(up)][grtC`indexList] = {up};
 ObjDef[e3(up)][grtC`calcFn] = grtF`calce3up;
 ObjDef[e3(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[e3(up)][grtC`depends] = { grt`e[bdn,up] };

grtF`calce3up [object_, list_] :=
Module[ {	s},
  s = ebdnup[metricName,3,a1];
  Return[s];
]; (* end Module *)

(* ------------------------------------------------------------------- *)
(*  Basis vector, e4(up) *)
(* ------------------------------------------------------------------- *)
 ObjDef[e4(up)][grtC`header] = "Basis (contravariant components)";
 ObjDef[e4(up)][grtC`root] = e4up;
 ObjDef[e4(up)][grtC`rootStr] = "e4";
 ObjDef[e4(up)][grtC`indexList] = {up};
 ObjDef[e4(up)][grtC`calcFn] = grtF`calce4up;
 ObjDef[e4(up)][grtC`symmetry] = grtF`symvector;
 ObjDef[e4(up)][grtC`depends] = { grt`e[bdn,up] };

grtF`calce4up [object_, list_] :=
Module[ {	s},
  s = ebdnup[metricName,4,a1];
  Return[s];
]; (* end Module *)

End[];

