(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 

Begin["grtG`"];

 ObjDef[grt`M2S][grtC`header] = "CM invariant Re(M2)";
 ObjDef[grt`M2S][grtC`root] = grtG`M2S;
 ObjDef[grt`M2S][grtC`rootStr] = "M2S ";
 ObjDef[grt`M2S][grtC`indexList] = {};
 ObjDef[grt`M2S][grtC`calcFn] = grtF`calcM2S;
 ObjDef[grt`M2S][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`M2S][grtC`depends] = {grt`S[up,up], grt`S[dn,dn],
		    grt`Weyl[dn,dn,dn,dn], grt`Weyl[up,up,up,up]};

grtF`calcM2S[ object_, iList_] :=
Module[ { a, b, c, d, e, f, s1, s2},
  (*  
   *  check for tensor/basis mode. Hardwire for Mma 
   *)
  s1 = 0;
   For[ c = 1, c <=  Ndim[metricName] , c++ ,
    For[ d = 1, d <=  Ndim[metricName] , d++ ,
      If[ Supup[metricName,c,d] =!= 0 , (* then *)
      For[ e = 1, e <=  Ndim[metricName] , e++ ,
	For[ f = 1, f <=  Ndim[metricName] , f++ ,
	If[ Sdndn[metricName,e,f] =!= 0 , (* then *)
	  For[ a = 1, a <=  Ndim[metricName] , a++ ,
	    For[ b = 1, b <=  Ndim[metricName] , b++ ,
	      s1 = s1 + Supup[metricName,c,d] * 
			Sdndn[metricName,e,f]
		    * Weyldndndndn[metricName,a,c,d,b]* 
		      Weylupupupup[metricName,a,e,f,b];
	      ]; (* end For *)
	    ]; (* end For *)
	    If[ fnCode  ===  grtC`calcalter  , (* then *)
	       s1 = simpHow[s1];
	    ]; (* end If *)
	  ]; (* end If *)
	  ]; (* end For *)
	]; (* end For *)
      ]; (* end If *)
    ]; (* end For *)
  ]; (* end For *)

  Return[s1/16];
]; (* end Module *)

(* ---------------------------- *)
(*  M5S *)
(* ---------------------------- *)
 ObjDef[grt`M5S][grtC`header] = "CM invariant M5S";
 ObjDef[grt`M5S][grtC`root] = grtG`M5S;
 ObjDef[grt`M5S][grtC`rootStr] = "M5S ";
 ObjDef[grt`M5S][grtC`indexList] = {};
 ObjDef[grt`M5S][grtC`calcFn] = grtF`calcM5S;
 ObjDef[grt`M5S][grtC`symmetry] = grtF`symscalar;
 ObjDef[grt`M5S][grtC`depends] = {grt`S[up,up], grt`Weyl[dn,dn,dn,dn], 
	grt`Weyl[up,up,up,up]};

grtF`calcM5S[ object_, iList_] :=
Module[ { c,d,e,f,s2},
 (*  
  *  check for tensor/basis mode. (hardwire for Mma) 
  *)
    (*  tensor *)

s2 = 0;
For[ c = 1, c <=  Ndim[metricName] , c++ ,
  For[ d = 1, d <=  Ndim[metricName] , d++ ,
     If[ Supup[metricName,c,d] =!= 0  , (* then *)
       For[ e = 1, e <=  Ndim[metricName] , e++ ,
	  For[ f = 1, f <=  Ndim[metricName] , f++ ,
	    If[ Supup[metricName,e,f] =!= 0 , (* then *)

s2 = s2 + Supup[metricName,c,d]*Supup[metricName,e,f]*(Weylupupupup[metricName,3,1,4,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,3,3,3,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,2,4,3,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,3,1,2,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,2,1,1,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,3,1,4,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,3,2,1,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,3,4,4,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,2,1,4,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,3,1,2,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,1,1,3,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,3,4,4,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,2,1,3,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,3,1,2,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,1,1,4,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,2,1,3,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,2,3,2,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,2,4,1,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,2,1,1,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,2,1,1,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,2,4,3,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,1,4,4,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,2,2,3,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,1,2,3,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,2,4,2,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,3,2,4,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,4,2,2,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,2,4,4,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,2,3,4,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,4,2,4,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,2,2,3,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,4,3,3,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,1,4,2,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,2,1,2,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,4,4,3,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,2,4,4,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,1,4,4,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,3,4,1,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,3,2,1,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,1,3,2,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,4,4,3,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,2,3,4,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,2,3,3,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,3,3,3,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,3,2,3,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,1,1,1,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,1,4,3,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,2,4,2,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,1,4,1,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,1,2,4,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,1,2,3,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,2,3,1,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,1,3,3,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,1,1,2,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,1,3,4,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,1,4,3,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,1,1,2,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,1,3,3,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,2,2,1,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,1,1,3,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,2,4,3,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,2,1,2,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,2,3,3,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,2,4,4,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,2,4,4,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,2,3,4,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,1,2,4,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,2,4,2,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,1,3,4,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,2,1,2,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,2,3,4,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,1,4,1,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,2,1,2,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,2,2,4,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,1,4,2,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,3,2,2,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,2,2,1,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,2,2,2,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,1,3,3,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,2,4,2,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,3,1,3,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,2,4,1,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,3,4,2,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,3,1,1,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,2,2,1,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,2,1,4,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,3,3,4,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,2,4,1,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,3,4,3,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,2,3,1,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,1,3,1,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,1,2,2,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,2,4,1,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,2,1,3,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,1,2,1,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,2,1,4,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,2,3,2,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,3,3,1,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,2,2,1,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,3,1,3,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,1,2,2,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,2,2,2,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,1,1,1,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,3,1,4,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,2,1,3,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,1,3,4,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,3,2,4,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,1,4,2,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,2,3,1,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,3,1,1,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,2,2,4,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,2,3,3,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,2,2,4,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,1,1,4,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,2,3,2,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,1,4,1,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,3,2,1,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,1,3,1,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,2,3,3,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,2,2,4,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,2,3,1,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,3,4,1,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,2,2,2,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,2,2,3,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,3,3,2,1]*Weyldndndndn[
metricName,3,c,d,1]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,2,2,3,4]*Weyldndndndn[
metricName,2,c,d,4]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,2,1,4,2]*Weyldndndndn[
metricName,2,c,d,2]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,2,2,2,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,1,3,2,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,2,1,1,3]*Weyldndndndn[
metricName,2,c,d,3]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,2,4,3,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,1,4,4,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,1,4,3,3]*Weyldndndndn[
metricName,1,c,d,3]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,2,3,2,1]*Weyldndndndn[
metricName,2,c,d,1]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,1,2,1,4]*Weyldndndndn[
metricName,1,c,d,4]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,3,2,2,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,3,2,3,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,3,3,1,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,3,3,2,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,3,3,3,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,3,3,4,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,3,4,1,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,3,4,2,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,3,4,3,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,3,4,4,2]*Weyldndndndn[
metricName,3,c,d,2]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,4,1,2,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,4,1,3,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,4,1,4,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,4,2,1,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,4,2,2,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,4,2,3,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,4,2,4,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,4,3,1,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,4,3,2,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,4,3,4,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,4,4,1,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,4,4,2,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,4,4,3,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,4,4,4,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,4,1,1,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,4,1,2,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,4,1,3,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,4,1,4,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,1,2,2,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,1,2,2,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,1,1,4,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,1,3,1,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,1,3,3,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,1,1,3,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,1,1,2,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,1,2,1,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,1,2,1,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,1,1,3,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,1,1,1,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,1,2,4,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,1,2,3,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,1,3,2,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,1,1,4,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,1,2,3,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,1,3,2,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,1,2,4,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,1,1,2,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,1,3,4,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,1,4,2,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,1,4,1,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,1,4,3,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,1,4,4,1]*Weyldndndndn[
metricName,1,c,d,1]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,1,1,1,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,1,3,1,2]*Weyldndndndn[
metricName,1,c,d,2]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,4,2,1,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,3,1,1,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,3,1,2,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,3,1,3,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,3,2,1,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,3,2,2,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,3,2,3,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,3,2,4,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,3,3,1,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,3,3,2,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,3,3,3,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,3,3,4,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,3,4,1,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,3,4,2,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,3,4,3,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,3,4,4,3]*Weyldndndndn[
metricName,3,c,d,3]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,3,1,1,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,3,1,3,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,3,1,4,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,3,2,2,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,3,2,3,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,3,2,4,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,3,3,1,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,3,3,2,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,3,3,4,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,3,4,2,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,3,4,3,4]*Weyldndndndn[
metricName,3,c,d,4]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,4,1,1,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,4,1,2,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,4,1,3,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,4,1,4,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,4,2,1,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,4,2,2,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,4,2,3,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,4,3,1,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,4,3,2,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,4,3,3,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,4,3,4,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,4,4,1,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,4,4,2,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,4,4,3,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,4,e,f,3]+Weylupupupup[metricName,4,4,4,1]*Weyldndndndn[
metricName,4,c,d,1]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,4,1,1,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,4,1,2,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,1,e,f,2]+Weylupupupup[metricName,4,1,3,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,1,e,f,3]+Weylupupupup[metricName,4,1,4,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,1,e,f,4]+Weylupupupup[metricName,4,2,1,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,2,e,f,1]+Weylupupupup[metricName,4,2,2,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,2,e,f,2]+Weylupupupup[metricName,4,2,3,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,4,2,4,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,4,3,1,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,4,3,2,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,4,3,3,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,4,3,4,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,4,4,1,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,4,4,2,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,4,4,4,2]*Weyldndndndn[
metricName,4,c,d,2]*Weyldndndndn[metricName,4,e,f,4]+Weylupupupup[metricName,4,1,1,3]*Weyldndndndn[
metricName,4,c,d,3]*Weyldndndndn[metricName,1,e,f,1]+Weylupupupup[metricName,4,2,3,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,2,e,f,3]+Weylupupupup[metricName,4,2,4,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,2,e,f,4]+Weylupupupup[metricName,4,3,1,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,3,e,f,1]+Weylupupupup[metricName,4,3,2,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,3,e,f,2]+Weylupupupup[metricName,4,3,3,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,3,e,f,3]+Weylupupupup[metricName,4,3,4,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,3,e,f,4]+Weylupupupup[metricName,4,4,1,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,4,e,f,1]+Weylupupupup[metricName,4,4,2,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,4,e,f,2]+Weylupupupup[metricName,4,4,4,4]*Weyldndndndn[
metricName,4,c,d,4]*Weyldndndndn[metricName,4,e,f,4]);

		If[ fnCode  ===  grtC`calcalter , (* then *)
		 s2 = simpHow[s2];
		]; (* end If *)
	  ]; (* end If *)
	]; (* end For *)
	  ]; (* end For *)
	]; (* end If *)
  ]; (* end For *)
]; (* end For *)
Return[s2/32];
]; (* end Module *)

End[];


