(* 
* GRTensorM (c) 1996-98 by Peter Musgrave, Denis Pollney and Kayll Lake
* All rights Reserved. Update by Mustapha Ishak B.
* GRTensorM is provided free of charge on the condition that it is
* acknowledged that we accept no liability for software performance,
* continued maintenance, or damage to data. The authors retain any and
* all rights to the software known as GRTensor, GRTensorII and
* GRTensorM their documentation and distribution. 
*) 

Begin["grtG`"];

(* ------------------------------------------------- *)
(*  grtF`calcDetg *)
(*  (calculate detg given gdndn or gupup) *)
(* ------------------------------------------------- *)

grtF`calcDetg[  startpt_] :=
Module[ {i,j,dim,gg},
  dim = Ndim[metricName];

  gg = Table[ startpt[metricName,i,j],
	 {i,dim},{j,dim}];
  detg[metricName] = Det[gg];

  If[ startpt  ===  gupup , (* then *)
     detg[metricName] = 1/detg[metricName];
  ]; (* end If *)
]; (* end Module *)

(* ------------------------------------------------- *)
(*  grtF`invMetric *)
(*  (create gupup given gdndn, or gdndn given gupup) *)
(* ------------------------------------------------- *)
grtF`invMetric[ endpt_,startpt_ ] := 

Module[ {i,j,dim,gg,hh,det},

  dim = Ndim[metricName];

  (*
   * do the symmetry assignments 
   *)
  For[ i = 1, i <=  dim-1 , i++ ,
     For[ j = i+1,  j <=  dim , j++ ,
	endpt[metricName,j,i] = endpt[metricName,i,j];
     ]; (* end For *)
  ]; (* end For *)

  gg = Table[ startpt[metricName,i,j],{i,dim},{j,dim}];
  hh = Inverse[gg];
  (*  
   * now copy the table back to our internal rep. 
   *)
  For[ i = 1, i <=  dim , i++ ,
    For[ j = i,  j <=  dim , j++ ,
      endpt[metricName,i,j] = hh[[i,j]];
    ]; (* end For *)
  ]; (* end For *)

]; (* end Module *)

End[];

